//****************************************************************************
//
//
//        The Minus4 project - Copyright (c) Mike Dailly 1996,7
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//
//										  6502.C
//                                      
//					 This file contains the 6502 emulation
//
// This source
//
//
// Version  By   Date     Description
//
// v1.00    MD 08/04/96	  All Instructions emulated in high level
// V1.2	   MD 28/07/97	  Perhaps I should have kept up this list...
//                        I'll try in future.          		 
// V1.21    MD 26/09/97   Added "OAL" and another "SKB" instruction
//                                 		 
//
// Last screen raster = $137 (311) - checked on the Plus 4
//	Cycles per scanline= (slow)57  (fast) 114 - 5 RAM refresh = 109
//
//****************************************************************************
#include "headers\md.h"
#include "headers\all.h"
#include "headers\screen.h"
#include "headers\draw.h"
#include "headers\6502asm.h"
#include "headers\disasm.h"
#include "headers\keyb.h"
#include	"headers\keyboard.h"
#include	"headers\sound.h"

extern	uint32	VBLANK;
extern	uint8		*pBuffer1;	// TED samples
extern	uint8		*pBuffer2;	// SID channel 1
extern	uint8		*pBuffer3;	// SID channel 2
extern	uint8		*pBuffer4;	// SID channel 3
extern	uint8		*pBuffer5;	// SID samples
extern	uint8		*pBuffer6;
extern	uint8		*pBuffer7;
extern	uint8		*pBuffer8;	// output "mixed" channel

#define	framecount	SCREEN_LINES*CYCLES_PER_LINE


#define	word	unsigned short
#define	byte	unsigned char
#define	CHECKKEY \
			  key=kbhit(); \
			  if (key!=0x0) break;

// 65816
//#define _V	   1
//#define _D	   2
//#define _I	   4
//#define _C	   8
//#define _Z	   16
//#define _N	   32
//#define _B	   64

// 8501
#define _C	   1
#define _Z	   2
#define _I	   4
#define _D	   8
#define _B	   16
#define _V	   64
#define _N	   128


#define	_1MHZ				0
#define	_1_78MHZ			1

extern	uint8	col;
enum	OPCODES{
			_UNKNOWN,
			_ADC,	_AND,			

			_ASL,	_BCC,	_BCS,	_BEQ,	_BIT,	_BMI,	_BNE,	_BPL,	_BRK,	_BVC,			
			_BVS,	_CLC,	_CLD,	_CLI,	_CLV,	_CMP,	_CPX,	_CPY,	_DEC,	_DEX,			
			_DEY,	_EOR, _INC, _INX, _INY, _JMP, _JSR, _LDA, _LDX, _LDY,
			_LSR, _NOP, _ORA, _PHA, _PHP, _PLA, _PLP, _ROL, _ROR, _RTI,
			_RTS, _SBC, _SEC, _SED, _SEI, _STX, _STY,	_TAX,	_TAY,	_TSX,			
			_TXA,	_TXS, _TYA,	
			_ADC_69,	_ADC_65,	_ADC_75,	_ADC_6d,	_ADC_7d,	_ADC_79,	_ADC_61,	
			_ADC_71,	
			_ASL_0a,	_ASL_06,	_ASL_16,	_ASL_0e,	_ASL_1e,	_BIT_24,
			_BIT_2c,
			_AND_29,	_AND_25,	_AND_35,	_AND_2d,	_AND_3d,	_AND_39,	_AND_21,
			_AND_31,
			_CMP_c9,	_CMP_c5, _CMP_d5,	_CMP_cd, _CMP_dd, _CMP_d9,	_CMP_c1, 
			_CMP_d1,
			_CPX_e0, _CPX_e4,	_CPX_ec,
			_CPY_c0,	_CPY_c4,	_CPY_cc,			
			_DEC_c6,	_DEC_d6,	_DEC_ce,	_DEC_de,			
			_EOR_49, _EOR_45,	_EOR_55,	_EOR_4d,	_EOR_5d,	_EOR_59,	_EOR_41,
			_EOR_51,
			_INC_e6,	_INC_f6,	_INC_ee,	_INC_fe,			
			_JMP_4c,	_JMP_6c,			

			_LDA_A9,		
			_LDA_A5,		
			_LDA_B5,		
			_LDA_AD,		
			_LDA_BD,		
			_LDA_B9,		
			_LDA_A1,		
			_LDA_B1,		

			_LDX_a2,			
			_LDX_a6,			
			_LDX_b6,			
			_LDX_ae,			
			_LDX_be,			

			_LDY_a0,			
			_LDY_a4,			
			_LDY_b4,			
			_LDY_ac,			
			_LDY_bc,			

			_LSR_4a,			
			_LSR_46,			
			_LSR_56,			
			_LSR_4e,			
			_LSR_5e,			

			_ORA_09,			
			_ORA_05,			
			_ORA_15,			
			_ORA_0d,			
			_ORA_1d,			
			_ORA_19,			
			_ORA_01,			
			_ORA_11,			

			_ROL_2a,			
			_ROL_26,			
			_ROL_36,			
			_ROL_2e,			
			_ROL_3e,			

			_ROR_6a,			
			_ROR_66,			
			_ROR_76,			
			_ROR_6e,			
			_ROR_7e,			

			_STA_85,			
			_STA_95,			
			_STA_8d,			
			_STA_9d,			
			_STA_99,			
			_STA_81,			
			_STA_91,			

			_STX_86,			
			_STX_96,			
			_STX_8e,			

			_STY_84,
			_STY_94,
			_STY_8c,

			_SBC_e9,			
			_SBC_e5,			
			_SBC_f5,			
			_SBC_ed,			
			_SBC_fd,			
			_SBC_f9,			
			_SBC_e1,			
			_SBC_f1,			

			_INS,			
			_LAX,			
			_SKB,			
			_AXS,			
			_DCM,			
			_SKW,			
			_LSE,			
			_RRA,			
			_RLA,			
			_OAL,			
			_ALR,			
			_SAX,			
			_HLT			
};


void ProcessADC_C( void );
void ProcessAND_C( void );
void ProcessASL_C( void );
void ProcessBCC_C( void );
void ProcessBCS_C( void );
void ProcessBEQ_C( void );
void ProcessBIT( void );
void ProcessBMI_C( void );
void ProcessBNE_C( void );
void ProcessBPL_C( void );
void ProcessBRK_C( void );
void ProcessBVC_C( void );
void ProcessBVS_C( void );
void ProcessCLC_C( void );
void ProcessCLD_C( void );
void ProcessCLI_C( void );
void ProcessCLV_C( void );
void ProcessCMP_C( void );
void ProcessCPX( void );
void ProcessCPY( void );
void ProcessDEC( void );
void ProcessDEX_C( void );
void ProcessDEY_C( void );
void ProcessEOR( void );
void ProcessINC( void );
void ProcessINX_C( void );
void ProcessINY_C( void );
void ProcessJMP( void );
void ProcessJSR_C( void );
void ProcessLDA( void );
void ProcessLDX_C( void );
void ProcessLDY_C( void );
void ProcessLSR_C( void );
void ProcessNOP_C( void );
void ProcessORA_C( void );
void ProcessPHA( void );
void ProcessPHP( void );
void ProcessPLA( void );
void ProcessPLP( void );
void ProcessROL( void );
void ProcessROR( void );
void ProcessRTI( void );
void ProcessRTS( void );
void ProcessSBC( void );
void ProcessSEC( void );
void ProcessSED( void );
void ProcessSEI( void );
void ProcessSTA_C( void );
void ProcessSTX_C( void );
void ProcessSTY_C( void );
void ProcessTAX( void );
void ProcessTAY( void );
void ProcessTSX( void );
void ProcessTXA( void );
void ProcessTXS( void );
void ProcessTYA( void );

void ProcessINS( void );
void ProcessLAX( void );
void ProcessDCM( void );
void ProcessLSE( void );

//	void *Jumps[2]={ProcessINS,
//						 ProcessINS};

	#include "6502\jump.c"


	uint32	CYCLES_PER_LINE_ON=CYCLES_PER_LINE_ON_def;				// ++ NORMAL ON  SCREEN CYCLES ++ 
	uint32	CYCLES_PER_LINE_OFF=CYCLES_PER_LINE_OFF_def;			// ++ NORMAL OFF SCREEN CYCLES ++ 
	uint32	IRQ_START_CYCLE=7;	//4;?!?!
//	uint32	IRQ_START_CYCLE=1;	//8;

	uint8		*ROMS[16];
	uint32	DRAW_LINE=2;			//2

	char 		hexbuff[16]={"0123456789ABCDEF"};
	uint8		*Memory;						// main memory
	uint32	*MemoryReadTable;
	uint32	*MemoryWriteTable;
	uint32	*MemoryRead;			// pointer to variables to flag when written to
	uint32	*MemoryWrite;		// pointer to variables to flag when written to
	uint32	*MemoryRead2;		// pointer to variables to flag when written to
	uint32	DummyWriteVariable;			// the dummy variable



extern	unsigned char		_A;
extern	unsigned char		_X;
extern	unsigned char		_Y;
extern	unsigned char		_F;
extern	unsigned char		_SP;
extern	uint32	 			_PC;  

	uint32	Screen2,VidBase2;
	uint32	DoneSample=0;

	uint32	testjoy=0;
	uint32	Joystick_active=0,joy_max_x=0;
	uint32	joy_max_y=0,joy_min_x=0xffffffff,joy_min_y=0xffffffff;
	uint32	joy_cen_x=0,joy_cen_y=0;
	uint32	Joy1=0;					// actual direction bits, 1=up, 2=down, 4=left, 8=right, 16=button

	uint8		skipit=0;
	uint8		CharLine=0;				// current line in character BITMAP being drawn!
	uint32	CharRow=0;				// current character ROW being processed.

	uint32	FlashCount;
	uint32	cTimer1=0;							// Current Timer
	uint32	Timer1=0;							// timer init value
	uint32	TIMER1_LO;							// value written to LOW?
	uint8		*pTimer1Lo=(&cTimer1)+2;
	uint8		*pTimer1Hi=(&cTimer1)+3;

	//	Timer delta array	0.885Mhz
	uint32	TimerCounts1[17]={0,1<<16,2<<16,3<<16,4<<16,5<<16,6<<16,7<<16,8<<16,9<<16,10<<16,11<<16,12<<16,13<<16,14<<16,15<<16,16<<16};

	//	Timer delta array	1.77Mhz
	uint32	TimerCounts2[17]={0,1<<15,2<<15,3<<15,4<<15,5<<15,6<<15,7<<15,8<<15,9<<15,10<<15,11<<15,12<<15,13<<15,14<<15,15<<15,16<<15};

	uint32	AND_IRQ=0;
	uint32	JOYSTICK;
	uint32	ROM;						// rom active flag!
	uint32	ROMINF;					// rom low number
	uint32	KEYBOARD_LATCH=0;		// accessed (written) keyboard latch!
	uint32	KEYBOARD_LATCH_2=0;	// accessed (written) keyboard latch!

	uint32	BrkPoint[10];

	uint32	CPU_MODE=0;				// 0 = 1Mhz mode, Not 0 = 1.78Mhz
	uint8		TimerLow;
	uint8		TimerHigh;
	uint16		newpc;
	uint32		LAST_PC;
	uint8		ThisLine=0;
	uint8		Last_ff09=0;
	int		_ret;
	int32		aa;
	uint32	charcount;
	uint32	LastLine;
	char		*pFileName;
	uint8		CharAttribute[40];				// read on the LAST line of the previous character
	uint8		CharNumber[40];					// read on the FIRST line of the character
	uint32	ScreenIndexArray[200*40];			// Screen index array...
	char 		Opcode_Table[256];
	int32  	mem_break;	
	int32  	brk_address;	
	int32		do_break;	
	int32		_screen;
	uint32	NextCycles;
	uint32	NextCycle_base;
	uint32	Cycles;
	uint32	CycleCount;
	uint32	LineCycles=0;			// okay? :-)
	int32		ScreenLine;
	uint32	RasterLine;
	uint32	opcode;

	uint32	r1,r2;
	uint32	MemDump;
	uint32	DoLine;

	uint32	EXIT_PRG=0;
	uint32	CYCLES_PER_LINE=CYCLES_PER_LINE_ON_def;
	int32		scroffset=4;
	int32		IRQrast;
	uint32	mem_ff1e;			// char counter..
	uint32	mem_ff1e_delta;

	uint32	DontInc;

	uint32	CycleIndex[255];
	byte	data;
	uint16	_d1;

	uint32	TESTPEEK=0;



uint8 GETABYTE( void );
#pragma aux GETABYTE =					\
		"mov	ecx,_PC"						\
		"mov  al,cl"						\
		"shl	ecx,2"	   				\
		"and  al,3"							\
		"add	ecx,MemoryReadTable"		\
		"mov	ecx,[ecx]"					\
		"or	cl,al"						\
		"inc	_PC"							\
		"mov	cl,[ecx]"					\
		modify [ecx al]					\
	   value [cl]


uint16 GETAWORD( void );
#pragma aux GETAWORD =					\
		"mov	ecx,_PC"						\
		"mov  al,cl"						\
		"shl	ecx,2"	   				\
		"and  al,3"							\
		"add	ecx,MemoryReadTable"		\
		"mov	ecx,[ecx]"					\
		"or	cl,al"						\
		"add	word ptr _PC,2"			\
		"mov	cx,[ecx]"					\
		modify [ecx al]					\
	   value [cx]


void DOCOMP( uint8 val );
#pragma aux DOCOMP =						\
	"and	eax,255"							\
	"mov	ebx,dword ptr _F"				\
	"and	ebx,4+8+64+1+16"				\
	"or	bl,CompTable[eax]"			\
	"mov	dword ptr _F,ebx"				\
	parm caller [al]						\
	modify [eax]							

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

uint8	ReadJoystickButtons	( void )
{
	outp		(JOYPORT,0);		// clear the latch and request a sample
	return	( (inp(JOYPORT)&0xf0) );	// return all buttons
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void CalabrateJoystick ( void )
{
	char	s[128];
	uint32	X,Y;		 
	
	SetMode(3);
	ScreenMode=CharScreen;
	_screen=1;
	wipe();

	joy_max_x=0;
	joy_max_y=0;
	joy_min_x=0xffffffff;
	joy_min_y=0xffffffff;
	joy_cen_x=0;
	joy_cen_y=0;

	PrintLine ( 0,0, "Wiggle joystick in ALL directions then release and press fire or ESCAPE" );
	while ( ((ReadJoystickButtons()&0xf0)==0xf0) AND (Keys[K_ESCAPE]==0)) {

		WaitVBlank(); 									// slow down a bit...
		delay (2);										// just in case VBLANK doesn't work (some video cards)

		X=ReadJoystick(JOYSTICK_1_X);				// get X axis
		delay (2);										// allow the joystick to reset (ready for another test)

		if (X>joy_max_x) joy_max_x=X;
		if (X<joy_min_x) joy_min_x=X;
		sprintf(s,"Current X=%d    ",X);
		PrintLine ( 0,2, s );	  
		sprintf(s,"Max X    =%d    ",joy_max_x);
		PrintLine ( 0,3, s );
		sprintf(s,"Min X    =%d    ",joy_min_x);
		PrintLine ( 0,4, s );

		Y=ReadJoystick(JOYSTICK_1_Y);	// get Y axis

		if (Y>joy_max_y) joy_max_y=Y;
		if (Y<joy_min_y) joy_min_y=Y;
		sprintf(s,"Current Y=%d    ",Y);
		PrintLine ( 20,2, s );
		sprintf(s,"Max Y    =%d    ",joy_max_y);
		PrintLine ( 20,3, s );
		sprintf(s,"Min Y    =%d    ",joy_min_y);
		PrintLine ( 20,4, s );
	}
	
	// user has released joystick, so get center
	joy_cen_x=ReadJoystick(JOYSTICK_1_X);	
	delay (2);
	joy_cen_y=ReadJoystick(JOYSTICK_1_Y);	
	delay (2);

	wipe();	
	ScreenMode=BitMapScreen;
	InitScreen ();
	_screen=1;
	CopyScreen (1);
	Joystick_active=1;			// Been through calabrate at least once.
}

//***********************************************************
//                                                          *
//   Name    : ProcessJoyStick                              *
//   Function: This processes an "analoge" joystick.			*
//             This works by takeing a left,right and center*
//             reading, and then taking half of each 			*
//					distance, this gives something like this.		*
//																				*
//						------------------------						*
//						                        						*
//						                        					   *
//						                        						*
//						                        						*
//						     ---------        						*
//						                      						*
//						                      						*
//						     Dead Zone        						*
//						                      						*
//						                      						*
//						     ---------        						*
//						                        						*
//						                        						*
//						                        						*
//						                        						*
//						                        						*
//						------------------------						*
//																				*
//					When the values are within the dead zone,   	*
//					there is no movement. Otherwise we set bits	*
//					in that direction.									*
//                                                          *
//   In   : none                                            *
//   Out  : Joy1 holds direction(s)									*
//                                                          *
//***********************************************************

#define	JOY_UP		1
#define	JOY_DOWN		2
#define	JOY_LEFT		4
#define	JOY_RIGHT	8
#define	JOY_BUTTON	16


void ProcessJoyStick ( void )
{
	uint32		X,Y;
	uint32		xd,yd;
	uint32		Lcx,Rcx,Tcy,Bcy;

	if (Joystick_active==0) return;		// no joystick attached.
	if ((JOYSTICK&3)==0) return;			// no joysticks active

	X = ReadJoystick(JOYSTICK_1_X);		// get X axis
	delay (1);									// seem to need this to allow the joystick to reset...Mmmmm.. On mine anyway!
	Y = ReadJoystick(JOYSTICK_1_Y);		// get Y axis

	Lcx=(joy_cen_x-joy_min_x)/2;			// get distance from LEFT to CENTER and div 2
	Rcx=(joy_max_x-joy_cen_x)/2;
	Tcy=(joy_cen_y-joy_min_y)/2;			// get distance from TOP to CENTER and div 2
	Bcy=(joy_max_y-joy_cen_y)/2;


	Joy1=0;
	if (X< (joy_cen_x-Lcx) ) Joy1+=JOY_LEFT;
	if (X> (joy_cen_x+Rcx) ) Joy1+=JOY_RIGHT;

	if (Y< (joy_cen_y-Tcy) ) Joy1+=JOY_UP;
	if (Y> (joy_cen_y+Bcy) ) Joy1+=JOY_DOWN;

	if (ReadJoystickButtons()!=0xf0) Joy1+=JOY_BUTTON;

}


//************************************************************
//                                                           *
//   Name    : FreezeGame                                    *
//   Function: Save the contents of memory, and any hardware *
//             info we will need to restart	                *
//                                                           *
//   In   : none (name?)                                     *
//   Out  : none                                             *
//                                                           *
//************************************************************
void FreezeGame( void )
{
	int		handle;
	uint16	Add;

	handle=open ("test.fre",O_WRONLY|O_BINARY|O_CREAT,S_IRWXU|S_IRWXG);
	Add=0x0000;
	write (handle,&Add,2);						// write load address

	write	(handle,&_PC,4);							// write register
	write	(handle,&_F,4);							// write register
	write	(handle,&_A,4);							// write register
	write	(handle,&_X,4);							// write register
	write	(handle,&_Y,4);							// write register
	write	(handle,&_SP,4);							// write register

	write	(handle,&ROMINF,4);						// write ROM bank data!
	write (handle,&ROM,4);							// ROM on/off?
	write (handle,&cTimer1,4);						// Current Timer
	write (handle,&Timer1,4);						// timer init value
	write (handle,&TIMER1_LO,4);					// value written to LOW?

	write (handle,Memory,0x10000);	// Dump ALL off memory!
	close (handle);
}


//****************************************************************************
//
// Peek and Deek. get a byte or word from memory
//
//****************************************************************************
byte PeekC ( word address )
{
	return (Memory[address]);
}
word DeekC ( word address )
{			
	unsigned short temp2;
	
	temp2=(unsigned short) (Memory[address+1]*256);
	temp2+=Memory[address];
	return (temp2);
}

//****************************************************************************
//
// Poke and Doke
//
//****************************************************************************
void PokeC ( word address, byte data )
{
//	uint8	*pMem;
//	void	(*Routine)();
//
//	if (MemoryWriteExe[address]!=0){
//		Routine=MemoryWriteTable[address];
//		Routine();
//	} else {
//		pMem=(uint8*) MemoryWriteTable[address];
//		*pMem=data;
//	}
//
//	if (mem_break==1) {
//		if (address==brk_address) do_break=1;
//	}
}

void DokeC ( word address, word data )
{
	Memory[address]=data & 0xff;
	Memory[address+1]=(data & 0xff00)>>8;
	if (mem_break==1) {
		if (address==brk_address) do_break=1;
	}
}




//****************************************************************************
//
// wait for a keypress
//
//****************************************************************************
void waitkey()
{
	char key=0x0;

	while (key==0x0) {
		key=kbhit();
	}
}

//****************************************************************************
//
//	
//
//****************************************************************************
int GetHex(char *st)
{
	int i=0,i2,i3;
	st++;	// past $

	while (st[0]!=0x0) {
	   if ((st[0]>='a') && (st[0]<='f')) st[0]-=32;
  		i=i*16;
		i3=0;
		for (i2=0;i2<16;i2++){
			if (st[0]==hexbuff[i2]) { i3=i2; }
		}
		i=i+i3;
		st++;
	}
	return (i);
}


//****************************************************************************
//
//	
//
//****************************************************************************
int Val(char *st)
{
	int i=0;	

	if (st[0]=='$') {
		i=GetHex(st);
	} else {
		while (st[0]!=0x0) {
	  		i=i*10;
			i=i+(st[0]-48);
			st++;
		}
	}
	return (i);
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//************************************************************

uint32 GetSize (char *pName)
{
struct stat		STAT;
	   uint32	size;

	stat(pName,&STAT);

	return (STAT.st_size);
}

//****************************************************************************
//
// Load data into memory
//
//****************************************************************************
void	LoadData ( uint8 *pMemory, int address, char *name )
{
	int handle;
	uint32	Size;

	Size=GetSize(name);
	
	handle=open (name,O_RDONLY|O_BINARY);
	if (handle!=-1) {
		printf ("         Loading file\n");
		read (handle,pMemory+address,Size);
		close (handle);
	}
}


//****************************************************************************
//
// Load data into memory
//
//****************************************************************************
void	LoadGame (char *name)
{
	int handle;
	uint16	add;
	uint32	Size;

	Size=GetSize(name);

	handle=open (name,O_RDONLY|O_BINARY);
	if (handle!=-1) {
		printf ("         Loading Game\n");
		read (handle,&add,2);
		read (handle,&(Memory[add]),Size-2);
		close (handle);
	}
	Doke(0x2b,0x1001);								// setup start of basic
	Doke(0x2d,(Size+add-2));					// setup start of basic
	Doke(0x9d,(Size+add-2));					// setup start of basic
}


//****************************************************************************
//
//  Hex - return Hex dig
//
//****************************************************************************
void Hex (char *buff,int number,int count)
{
	if (count==2){
		buff[0]=hexbuff[(number&0xF0)>>4];
		buff[1]=hexbuff[number&0x0F];
	} else {
		buff[0]=hexbuff[(number&0xF000)>>12];
		buff[1]=hexbuff[(number&0xF00)>>8];
		buff[2]=hexbuff[(number&0xF0)>>4];
		buff[3]=hexbuff[number&0xF];
	}
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void DumpMemory (int address)
{
	char	line[80];
	char	add[5]="0000";
	char	hx1[3]="00";
	char	hx2[3]="00";
	char	hx3[3]="00";
	char	hx4[3]="00";
	char	hx5[3]="00";
	char	hx6[3]="00";
	char	hx7[3]="00";
	char	hx8[3]="00";
	char	hx9[3]="00";
	char	hx10[3]="00";
	char	hx11[3]="00";
	char	hx12[3]="00";
	char	hx13[3]="00";
	char	hx14[3]="00";
	char	hx15[3]="00";
	char	hx16[3]="00";
	uint32	lp;	

  for (lp=0;lp<8;lp++)	{
  		Hex(&add,address,4);
  		Hex(&hx1,(int) Peek(address++),2);
  		Hex(&hx2,(int) Peek(address++),2);
  		Hex(&hx3,(int) Peek(address++),2);
  		Hex(&hx4,(int) Peek(address++),2);
  		Hex(&hx5,(int) Peek(address++),2);
  		Hex(&hx6,(int) Peek(address++),2);
  		Hex(&hx7,(int) Peek(address++),2);
  		Hex(&hx8,(int) Peek(address++),2);

		sprintf (line,"%s %s %s %s %s %s %s %s %s",add,hx1,hx2,hx3,hx4,hx5,hx6,hx7,hx8);
  		PrintLine (51,14+lp,line);
  }
  		PrintLine (51,12,"                             ");
  		PrintLine (51,13,"                             ");


//  for (lp=0;lp<8;lp++)	{
//  		Hex(&add,address,4);
//  		Hex(&hx1,(int) Peek(address++),2);
//  		Hex(&hx2,(int) Peek(address++),2);
//  		Hex(&hx3,(int) Peek(address++),2);
//  		Hex(&hx4,(int) Peek(address++),2);
//  		Hex(&hx5,(int) Peek(address++),2);
//  		Hex(&hx6,(int) Peek(address++),2);
//  		Hex(&hx7,(int) Peek(address++),2);
//  		Hex(&hx8,(int) Peek(address++),2);
//  		Hex(&hx9,(int) Peek(address++),2);
//  		Hex(&hx10,(int) Peek(address++),2);
//  		Hex(&hx11,(int) Peek(address++),2);
//  		Hex(&hx12,(int) Peek(address++),2);
//  		Hex(&hx13,(int) Peek(address++),2);
//  		Hex(&hx14,(int) Peek(address++),2);
//  		Hex(&hx15,(int) Peek(address++),2);
//  		Hex(&hx16,(int) Peek(address++),2);
//
//
//		sprintf (line,"%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s",add,hx1,hx2,hx3,hx4,hx5,hx6,hx7,hx8,hx9,hx10,hx11,hx12,hx13,hx14,hx15,hx16);
//  		PrintLine (0,12+lp,line);
//  }


}


//****************************************************************************
//
// Display Registers
//
//****************************************************************************
void Regs ( void )
{
  char 	line[80];
  char 	f[7];
  char 	pc[5];
  char 	ar[3];
  char 	xr[3];
  char 	yr[3];
  char 	sp[3];
  int32  lp,i;		//,aa;


//  return;

  strcpy (f,"0000000");
  strcpy (pc,"0000");
  strcpy (ar,"00");
  strcpy (xr,"00");
  strcpy (yr,"00");
  strcpy (sp,"00");
  Hex(&pc,_PC,4);
  Hex(&ar,_A,2);
  Hex(&xr,_X,2);
  Hex(&yr,_Y,2);
  Hex(&sp,_SP,2);

  if ((_F&_C)!=0){ f[6]='1'; }
  if ((_F&_Z)!=0){ f[5]='1'; }
  if ((_F&_I)!=0){ f[4]='1'; }
  if ((_F&_D)!=0){ f[3]='1';}
  if ((_F&_B)!=0){ f[2]='1';}
  if ((_F&_V)!=0){ f[1]='1';}
  if ((_F&_N)!=0){ f[0]='1';}


  for (i=0;i<80;i++) line[i]=0x0;
  //sprintf (line,"  PC   AC  XR  YR  NZCIDV",_A,_X,_Y);
  sprintf (line,"  PC   AC  XR  YR  SP  NVBDIZC",_A,_X,_Y,_SP);
  PrintLine (50,0,line);
	
  for (i=0;i<80;i++) line[i]=0x0;
  sprintf (line," %s  %s  %s  %s  %s  %s",pc,ar,xr,yr,sp,f);
  PrintLine (50,1,line);
  
  aa=0;
  for (lp=0;lp<10;lp++)	{
  		Disassemble(_PC+aa);
  		PrintLine (51,2+lp,"                        ");
  		PrintLine (51,2+lp,disline);
  	   aa+=adder;
  }

  DumpMemory (MemDump);

  sprintf (line,"Line Cycles=%d",LineCycles);
  PrintLine (51,13,line);

}


//****************************************************************************
//
// Various routines to get data from the Memory
//
//****************************************************************************
unsigned char GetByteC ( void )
{
	unsigned char temp;
	
	temp=Memory[_PC];
	_PC=(_PC+1)&0xffff;
	return (temp);
}

unsigned short GetWordC ( void )
{
	unsigned short temp2;
	
	temp2=(unsigned short) (Memory[_PC+1]*256);
	temp2+=Memory[_PC];
	_PC=(_PC+2)&0xffff;
	return (temp2);
}

//****************************************************************************
//
// Push and Dush
//
//****************************************************************************
void Push_C ( byte data )
{
	Memory[0x100+_SP]=data;
	_SP--;
}
void Dush_C ( word data )
{
	Memory[0x100+_SP-1]=data & 0xff;
	Memory[0x100+_SP]=(data & 0xff00)>>8;
	_SP-=2;
}

//****************************************************************************
//
// Pull and Dull
//
//****************************************************************************
void Pull ( byte *data )
{
	_SP++;
	*data=Memory[0x100+_SP];
}
void Dull ( word *data )
{
	_SP+=2;
	*data=Memory[0x100+_SP-1];
	*data+=(Memory[0x100+_SP]<<8);
}


//****************************************************************************
//
// Take a BRANCH instruction - signed offset byte is passed
//
//****************************************************************************
void TakeBranch( int8 offset)
{
	if (offset>127) {
		offset=-offset;
		_PC=(_PC-offset)&0xffff;
	} else {
		_PC=(_PC+(int) offset)&0xffff;
	}
}

//****************************************************************************
//
// Do the actual cmp command
//
//****************************************************************************
void DoCMP ( byte test )
{
	_F&=(_I+_D+_V+_B);
	if (test<128) {_F|=_N;}
	if (test==0) {_F|=_Z;}
	if (test<128) {_F|=_C;}
}

//****************************************************************************
//
// Do a compare with 0 (negative and zero checks)
//
//****************************************************************************
void COMP_C ( byte test )
{
	_F&=(_I+_D+_V+_C+_B);
	if ((test & 128)==128) {_F|=_N;}
	if (test==0) {_F|=_Z;}
}

#include "6502\adc.c"
#include "6502\alr.c"
#include "6502\and.c"
#include "6502\anc.c"
#include "6502\asl.c"
#include "6502\aso.c"
#include "6502\bcc.c"
#include "6502\bcs.c"
#include "6502\beq.c"
#include "6502\bit.c"
#include "6502\bmi.c"
#include "6502\bne.c"
#include "6502\bpl.c"
#include "6502\brk.c"
#include "6502\bvc.c"
#include "6502\bvs.c"
#include "6502\clc.c"
#include "6502\cld.c"
#include "6502\cli.c"
#include "6502\clv.c"
#include "6502\dcm.c"
#include "6502\cmp.c"
#include "6502\cpx.c"
#include "6502\cpy.c"
#include "6502\dec.c"
#include "6502\dex.c"
#include "6502\dey.c"
#include "6502\eor.c"
#include "6502\inc.c"
#include "6502\inx.c"
#include "6502\iny.c"
#include "6502\ins.c"
#include "6502\jmp.c"
#include "6502\jsr.c"
#include "6502\lda.c"
#include "6502\axs.c"
#include "6502\lax.c"
#include "6502\ldx.c"
#include "6502\ldy.c"
#include "6502\lse.c"
#include "6502\lsr.c"
#include "6502\nop.c"
#include "6502\ora.c"
#include "6502\oal.c"
#include "6502\pha.c"
#include "6502\php.c"
#include "6502\pla.c"
#include "6502\plp.c"
#include "6502\rla.c"
#include "6502\rol.c"
#include "6502\ror.c"
#include "6502\rra.c"
#include "6502\rti.c"
#include "6502\rts.c"
#include "6502\sax.c"
#include "6502\sbc.c"
#include "6502\sec.c"
#include "6502\sed.c"
#include "6502\sei.c"
#include "6502\sta.c"
#include "6502\stx.c"
#include "6502\sty.c"
#include "6502\tax.c"
#include "6502\tay.c"
#include "6502\tsx.c"
#include "6502\txa.c"
#include "6502\txs.c"
#include "6502\tya.c"
#include "6502\skb.c"
#include "6502\skw.c"
#include "6502\hlt.c"

//****************************************************************************
//
// Define Opcode Table
//
//****************************************************************************
void DefineOpcodeTable( void )
{
	//
	// ADC
	//
	Opcode_Table[0x69]=_ADC_69; Opcode_Table[0x65]=_ADC_65; Opcode_Table[0x75]=_ADC_75;
	Opcode_Table[0x6D]=_ADC_6d; Opcode_Table[0x7D]=_ADC_7d; Opcode_Table[0x79]=_ADC_79;
	Opcode_Table[0x61]=_ADC_61; Opcode_Table[0x71]=_ADC_71;

	// 
	// AND
	//
	Opcode_Table[0x29]=_AND_29; Opcode_Table[0x25]=_AND_25; Opcode_Table[0x35]=_AND_35;
	Opcode_Table[0x2D]=_AND_2d; Opcode_Table[0x3D]=_AND_3d; Opcode_Table[0x39]=_AND_39;
	Opcode_Table[0x21]=_AND_21; Opcode_Table[0x31]=_AND_31;

	//
	// ASL
	//
	Opcode_Table[0x0A]=_ASL_0a; Opcode_Table[0x06]=_ASL_06; Opcode_Table[0x16]=_ASL_16;
	Opcode_Table[0x0E]=_ASL_0e; Opcode_Table[0x1E]=_ASL_1e;

	//
	// Branches
	//
	Opcode_Table[0x90]=_BCC; Opcode_Table[0xB0]=_BCS; Opcode_Table[0xF0]=_BEQ;

	//
	// BIT
	//
	Opcode_Table[0x24]=_BIT_24;
	Opcode_Table[0x2C]=_BIT_2c;

	//
	// Branches
	//
	Opcode_Table[0x30]=_BMI; Opcode_Table[0xD0]=_BNE; Opcode_Table[0x10]=_BPL;

	//
	// BRK
	//
	Opcode_Table[0x00]=_BRK;

	//
	// Branches
	//
	Opcode_Table[0x50]=_BVC; Opcode_Table[0x70]=_BVS;

	//
	// FLAG INSTRUCTIONS
	//
	Opcode_Table[0x18]=_CLC; Opcode_Table[0xD8]=_CLD; Opcode_Table[0x58]=_CLI;
	Opcode_Table[0xB8]=_CLV;

	//
	// CMP
	//
	Opcode_Table[0xC9]=_CMP_c9; Opcode_Table[0xC5]=_CMP_c5; Opcode_Table[0xD5]=_CMP_d5;
	Opcode_Table[0xCD]=_CMP_cd; Opcode_Table[0xDD]=_CMP_dd; Opcode_Table[0xD9]=_CMP_d9;
	Opcode_Table[0xC1]=_CMP_c1; Opcode_Table[0xD1]=_CMP_d1;

	//
	// CPX
	//
	Opcode_Table[0xE0]=_CPX_e0; Opcode_Table[0xE4]=_CPX_e4; Opcode_Table[0xEC]=_CPX_ec;

	//
	// CPY
	//
	Opcode_Table[0xC0]=_CPY_c0; Opcode_Table[0xC4]=_CPY_c4; Opcode_Table[0xCC]=_CPY_cc;

	//
	// DEC, DEX, DEY
	//
	Opcode_Table[0xC6]=_DEC_c6; Opcode_Table[0xD6]=_DEC_d6; Opcode_Table[0xCE]=_DEC_ce;
	Opcode_Table[0xDE]=_DEC_de; 

	Opcode_Table[0xCA]=_DEX; 
	Opcode_Table[0x88]=_DEY;

	//
	// EOR
	//
	Opcode_Table[0x49]=_EOR_49; Opcode_Table[0x45]=_EOR_45; Opcode_Table[0x55]=_EOR_55;
	Opcode_Table[0x4D]=_EOR_4d; Opcode_Table[0x5D]=_EOR_5d; Opcode_Table[0x59]=_EOR_59;
	Opcode_Table[0x41]=_EOR_41; Opcode_Table[0x51]=_EOR_51;

	//
	// INC, INX, INY
	//
	Opcode_Table[0xE6]=_INC_e6; Opcode_Table[0xF6]=_INC_f6; Opcode_Table[0xEE]=_INC_ee;
	Opcode_Table[0xFE]=_INC_fe; 

	Opcode_Table[0xE8]=_INX; 
	Opcode_Table[0xC8]=_INY;
	
	//
	// JMP, JSR
	//
	Opcode_Table[0x4C]=_JMP_4c; Opcode_Table[0x6C]=_JMP_6c; Opcode_Table[0x20]=_JSR;

	//
	// LDA
	//
	Opcode_Table[0xA9]=_LDA_A9; Opcode_Table[0xA5]=_LDA_A5; Opcode_Table[0xB5]=_LDA_B5;
	Opcode_Table[0xAD]=_LDA_AD; Opcode_Table[0xBD]=_LDA_BD; Opcode_Table[0xB9]=_LDA_B9;
	Opcode_Table[0xA1]=_LDA_A1; Opcode_Table[0xB1]=_LDA_B1;

	//
	// LDX
	//
	Opcode_Table[0xA2]=_LDX_a2; Opcode_Table[0xA6]=_LDX_a6; Opcode_Table[0xB6]=_LDX_b6;
	Opcode_Table[0xAE]=_LDX_ae; Opcode_Table[0xBE]=_LDX_be;

	//
	// LDY
	//
	Opcode_Table[0xA0]=_LDY_a0; Opcode_Table[0xA4]=_LDY_a4; Opcode_Table[0xB4]=_LDY_b4;
	Opcode_Table[0xAC]=_LDY_ac; Opcode_Table[0xBC]=_LDY_bc;

	//
	// LSR
	//
	Opcode_Table[0x4A]=_LSR_4a; Opcode_Table[0x46]=_LSR_46; Opcode_Table[0x56]=_LSR_56;
	Opcode_Table[0x4E]=_LSR_4e; Opcode_Table[0x5E]=_LSR_5e;

	//
	// NOP
	//
	Opcode_Table[0xEA]=_NOP;
	Opcode_Table[0x1A]=_NOP;  // extended
	Opcode_Table[0x3A]=_NOP;
	Opcode_Table[0x5A]=_NOP;
	Opcode_Table[0x7A]=_NOP;
	Opcode_Table[0xDA]=_NOP;
	Opcode_Table[0xFA]=_NOP;

	//
	// ORA
	//
	Opcode_Table[0x09]=_ORA_09; Opcode_Table[0x05]=_ORA_05; Opcode_Table[0x15]=_ORA_15;
	Opcode_Table[0x0D]=_ORA_0d; Opcode_Table[0x1D]=_ORA_1d; Opcode_Table[0x19]=_ORA_19;
	Opcode_Table[0x01]=_ORA_01; Opcode_Table[0x11]=_ORA_11;
	
	//
	// PHA, PHP, PLA, PLP
	//
	Opcode_Table[0x48]=_PHA; Opcode_Table[0x08]=_PHP; Opcode_Table[0x68]=_PLA;
	Opcode_Table[0x28]=_PLP;

	//
	// ROL
	//
	Opcode_Table[0x2A]=_ROL_2a; Opcode_Table[0x26]=_ROL_26; Opcode_Table[0x36]=_ROL_36;
	Opcode_Table[0x2E]=_ROL_2e; Opcode_Table[0x3E]=_ROL_3e;

	//
	// ROR
	//
	Opcode_Table[0x6A]=_ROR_6a; Opcode_Table[0x66]=_ROR_66; Opcode_Table[0x76]=_ROR_76;
	Opcode_Table[0x6E]=_ROR_6e; Opcode_Table[0x7E]=_ROR_7e;

	//
	// RTI, RTS
	//
	Opcode_Table[0x40]=_RTI; Opcode_Table[0x60]=_RTS;

	//
	// SBC
	//
	Opcode_Table[0xE9]=_SBC_e9; Opcode_Table[0xE5]=_SBC_e5; Opcode_Table[0xF5]=_SBC_f5;
	Opcode_Table[0xED]=_SBC_ed; Opcode_Table[0xFD]=_SBC_fd; Opcode_Table[0xF9]=_SBC_f9;
	Opcode_Table[0xE1]=_SBC_e1; Opcode_Table[0xF1]=_SBC_f1;

	Opcode_Table[0xEB]=_SBC_e9;	// Not a normal SBC opcode!


	//
	// FLAG Instructions
	//
	Opcode_Table[0x38]=_SEC; Opcode_Table[0xF8]=_SED; Opcode_Table[0x78]=_SEI;

	//
	// STA
	//
	Opcode_Table[0x85]=_STA_85; Opcode_Table[0x95]=_STA_95; Opcode_Table[0x8D]=_STA_8d;
	Opcode_Table[0x9D]=_STA_9d; Opcode_Table[0x99]=_STA_99; Opcode_Table[0x81]=_STA_81;
	Opcode_Table[0x91]=_STA_91;

	//
	// STX
	//
	Opcode_Table[0x86]=_STX_86; Opcode_Table[0x96]=_STX_96; Opcode_Table[0x8E]=_STX_8e;

	//
	// STY
	//
	Opcode_Table[0x84]=_STY_84; Opcode_Table[0x94]=_STY_94; Opcode_Table[0x8C]=_STY_8c;

	//
	// TAX, TAY, TSX, TXA, TXS, TYA
	//
	Opcode_Table[0xAA]=_TAX; Opcode_Table[0xA8]=_TAY; Opcode_Table[0xBA]=_TSX;
	Opcode_Table[0x8A]=_TXA; Opcode_Table[0x9A]=_TXS; Opcode_Table[0x98]=_TYA;


	//
	// extended opcodes
	//
	Opcode_Table[0xE7]=_INS; Opcode_Table[0xF7]=_INS;
	Opcode_Table[0xEF]=_INS; Opcode_Table[0xFF]=_INS; Opcode_Table[0xFB]=_INS;
	Opcode_Table[0xE3]=_INS; Opcode_Table[0xF3]=_INS;

	Opcode_Table[0xA7]=_LAX; Opcode_Table[0xB7]=_LAX;
	Opcode_Table[0xAF]=_LAX; Opcode_Table[0xBF]=_LAX; Opcode_Table[0xA3]=_LAX;
	Opcode_Table[0xB3]=_LAX; 

	Opcode_Table[0x80]=_SKB; Opcode_Table[0x82]=_SKB; Opcode_Table[0xC2]=_SKB; 
	Opcode_Table[0xE2]=_SKB; Opcode_Table[0x04]=_SKB; Opcode_Table[0x14]=_SKB; 
	Opcode_Table[0x34]=_SKB; Opcode_Table[0x44]=_SKB; Opcode_Table[0x54]=_SKB; 
	Opcode_Table[0x64]=_SKB; Opcode_Table[0x74]=_SKB; Opcode_Table[0xD4]=_SKB; 
	Opcode_Table[0xF4]=_SKB; Opcode_Table[0x89]=_SKB;

	Opcode_Table[0x87]=_AXS; Opcode_Table[0x8F]=_AXS; Opcode_Table[0x97]=_AXS; 
	Opcode_Table[0x83]=_AXS; 

	Opcode_Table[0xC7]=_DCM; Opcode_Table[0xD7]=_DCM; Opcode_Table[0xCF]=_DCM; 
	Opcode_Table[0xDF]=_DCM; Opcode_Table[0xDB]=_DCM; Opcode_Table[0xC3]=_DCM; 
	Opcode_Table[0xD3]=_DCM; 


	Opcode_Table[0x0C]=_SKW; Opcode_Table[0x1C]=_SKW; Opcode_Table[0x3C]=_SKW; 
	Opcode_Table[0x5C]=_SKW; Opcode_Table[0x7C]=_SKW; Opcode_Table[0xdC]=_SKW; 
	Opcode_Table[0xfC]=_SKW; 


	Opcode_Table[0x47]=_LSE; Opcode_Table[0x57]=_LSE; Opcode_Table[0x4f]=_LSE; 
	Opcode_Table[0x5f]=_LSE; Opcode_Table[0x5b]=_LSE; Opcode_Table[0x43]=_LSE; 
	Opcode_Table[0x53]=_LSE; 

	Opcode_Table[0x67]=_RRA; Opcode_Table[0x77]=_RRA; Opcode_Table[0x6F]=_RRA; 
	Opcode_Table[0x7f]=_RRA; Opcode_Table[0x7b]=_RRA; Opcode_Table[0x63]=_RRA; 
	Opcode_Table[0x73]=_RRA; 

	Opcode_Table[0x27]=_RLA; Opcode_Table[0x37]=_RLA; Opcode_Table[0x2f]=_RLA; 
	Opcode_Table[0x3f]=_RLA; Opcode_Table[0x3b]=_RLA; Opcode_Table[0x23]=_RLA; 
	Opcode_Table[0x33]=_RLA; 

	Opcode_Table[0xAB]=_OAL; 
	Opcode_Table[0x4B]=_ALR; 
	Opcode_Table[0xCB]=_SAX;

	Opcode_Table[0x02]=_HLT; Opcode_Table[0x12]=_HLT; Opcode_Table[0x22]=_HLT;
	Opcode_Table[0x32]=_HLT; Opcode_Table[0x42]=_HLT; Opcode_Table[0x52]=_HLT;
	Opcode_Table[0x62]=_HLT; Opcode_Table[0x72]=_HLT; Opcode_Table[0x92]=_HLT;
	Opcode_Table[0xB2]=_HLT; Opcode_Table[0xD2]=_HLT; Opcode_Table[0xF2]=_HLT;
}




//****************************************************************************
//
// Init memory. Allocate etc..
//
//****************************************************************************
void	init6502( void )

{
	uint32	i,i2,i3,i4;
	uint32	*pMem;
	uint32	*pROM;

	pTimer1Lo=(uint8 *) (&cTimer1);
	pTimer1Lo+=2;
	pTimer1Hi=(uint8 *) (&cTimer1);
	pTimer1Hi+=3;

	FlashCount=0;		// Cursor flash counter

	printf ("         Allocating Plus4 System Memory\n");
	Memory=malloc (0x10000+0x2000);
	Memory+=0x1fff;
	if (Memory==NULL) {
		printf ("\nError: Can't allocate system memory.\n");
		exit(1);
	}
	Memory=(uint8 *) ((uint32) Memory&0xffffe000);

	printf ("         Allocating 1Mb for the memory mapping system\n");
	MemoryWrite=(uint32 *) malloc (0x40000);						// a mapping system for data access
	MemoryRead=(uint32 *) malloc (0x40000);						// a mapping system for data access (what to store)
	MemoryRead2=(uint32 *) malloc (0x40000);						// a mapping system for data access (what to store)
	if (MemoryWrite==NULL) {
		printf ("\nError: Can't Allocate Memory for Memory Mapping System.\n");
		exit(1);
	}
	if (MemoryRead==NULL) {
		printf ("\nError: Can't Allocate Memory for Memory Mapping System.\n");
		exit(1);
	}
	if (MemoryRead2==NULL) {
		printf ("\nError: Can't Allocate Memory for Memory Mapping System.\n");
		exit(1);
	}

	printf ("        Clearing memory and tables\n");
	for (i=0;i<0x10000;i++) {
		Memory[i]=0;									// clear memory
		MemoryRead[i]=((uint32) &Memory[i])&0xfffffffc;		// Set default mode (read from memory!)
		MemoryRead2[i]=((uint32) &Memory[i])&0xfffffffc;
		MemoryWrite[i]=((uint32) &Memory[i])&0xfffffffc;		// Set default mode (write to memory!)
	}
	MemoryWriteTable=MemoryWrite;
	MemoryReadTable=MemoryRead;

	// ROM on/off
	MemoryWrite[0xff3e]=(uint32) &RomOn|ROUTINE;				// ROM switched off!
	MemoryWrite[0xff3f]=(uint32) &RomOff|ROUTINE;				// ROM switched on!

	//	
	// Set up ROM numbers. Used in ROM paging
	//
	MemoryWrite[0xfdd0]=(uint32) &ROMINF_400|ROUTINE;		// MemoryWrite[0xfdd0]=0x400;							
	MemoryWrite[0xfdd1]=(uint32) &ROMINF_401|ROUTINE;		// MemoryWrite[0xfdd1]=0x401;						  
	MemoryWrite[0xfdd2]=(uint32) &ROMINF_402|ROUTINE;		//	MemoryWrite[0xfdd2]=0x402;						  
	MemoryWrite[0xfdd3]=(uint32) &ROMINF_403|ROUTINE;		// MemoryWrite[0xfdd3]=0x403;						  
	MemoryWrite[0xfdd4]=(uint32) &ROMINF_500|ROUTINE;		//	MemoryWrite[0xfdd4]=0x500;				  
	MemoryWrite[0xfdd5]=(uint32) &ROMINF_501|ROUTINE;	   //	MemoryWrite[0xfdd5]=0x501;				  
	MemoryWrite[0xfdd6]=(uint32) &ROMINF_502|ROUTINE;	  	// MemoryWrite[0xfdd6]=0x502;
	MemoryWrite[0xfdd7]=(uint32) &ROMINF_503|ROUTINE;		// MemoryWrite[0xfdd7]=0x503;
	MemoryWrite[0xfdd8]=(uint32) &ROMINF_600|ROUTINE;	   //	MemoryWrite[0xfdd8]=0x600;				  
	MemoryWrite[0xfdd9]=(uint32) &ROMINF_601|ROUTINE;	  	// MemoryWrite[0xfdd9]=0x601;				  
	MemoryWrite[0xfdda]=(uint32) &ROMINF_602|ROUTINE;	   //	MemoryWrite[0xfdda]=0x602;				  
	MemoryWrite[0xfddb]=(uint32) &ROMINF_603|ROUTINE;	  	//	MemoryWrite[0xfddb]=0x603;				  
	MemoryWrite[0xfddc]=(uint32) &ROMINF_700|ROUTINE;	  	//	MemoryWrite[0xfddc]=0x700;				  
	MemoryWrite[0xfddd]=(uint32) &ROMINF_701|ROUTINE;	  	//	MemoryWrite[0xfddd]=0x701;				  
	MemoryWrite[0xfdde]=(uint32) &ROMINF_702|ROUTINE;	   // MemoryWrite[0xfdde]=0x702;				  
	MemoryWrite[0xfddf]=(uint32) &ROMINF_703|ROUTINE;	   //	MemoryWrite[0xfddf]=0x703;							
														 
	MemoryWrite[0xff06]=(uint32) &ProcessFF06|ROUTINE;

	// 
	// If sound enabled, enable write detects. Otherwise leave it coz
	// we don't care..
	//
	if (SOUND==1){
		MemoryWrite[0xff0e]=(uint32) &Chanel1_Lo|ROUTINE;
		MemoryWrite[0xff0f]=(uint32) &Chanel2_Lo|ROUTINE;	
		MemoryWrite[0xff10]=(uint32) &Chanel2_Hi|ROUTINE;	
		MemoryWrite[0xff11]=(uint32) &Chanel_Select|ROUTINE;	
		MemoryWrite[0xff12]=(uint32) &Chanel1_Hi|ROUTINE;
	}
	// 
	MemoryWrite[0xff1d]   =(uint32) &_FF1D|ROUTINE;


	// flag keyboard writing.
	MemoryWrite[0xff08] =(uint32) &wKEYBOARD_LATCH|ROUTINE;		
	MemoryWrite[0xfd30] =(uint32) &wKEYBOARD_LATCH_2|ROUTINE;	
	MemoryRead[0xff08]=(uint32) &rKEYBOARD_LATCH|ROUTINE;
	MemoryRead2[0xff08]=(uint32) &rKEYBOARD_LATCH|ROUTINE;

	// IRQ wiping
	MemoryWrite[0xff09] =(uint32) &Clear_IRQS|ROUTINE;				

	// Setting the timer				
	MemoryWrite[0xff00]=(uint32) &wTIMER1_LO|ROUTINE;				
	MemoryWrite[0xff01]=(uint32) &wTIMER1_HIGH|ROUTINE;			


	printf ("         Allocating ROM space\n");
	for (i=0;i<MAXROM;i++){
		ROMS[i]=malloc (0x4000+0x2000);
		ROMS[i]+=0x1fff;
		if (ROMS[i]==NULL) {
			printf ("\nError: Can't Allocate Memory ROM's.\n");
			exit(1);
		}
		ROMS[i]=(uint8 *) ((uint32)ROMS[i] &0xffffe000);	// allocate 16k rom space.
		pMem=(uint32*) ROMS[i];
		for (i2=0;i2<0x1000;i2++) *pMem++=0;
	}


	printf ("         Loading basic ROM\n");
	LoadData(ROMS[0],0x0000,"c16basic.rom");		// load ROM to 0!
	printf ("         Loading kernal ROM\n");
	LoadData(ROMS[4],0x0000,"c16kern.rom");		// load ROM to 0

	LoadData(ROMS[1],0x0000,"3plus1lo.rom");
	LoadData(ROMS[5],0x0000,"3plus1hi.rom");
	*(ROMS[4]+0x3f08)=0xff;
	*(ROMS[5]+0x3f08)=0xff;
	*(ROMS[6]+0x3f08)=0xff;
	*(ROMS[7]+0x3f08)=0xff;

	printf ("         Loading character ROM\n");
	//LoadData(ROMS[4],0x1000,"c16char.rom");		


	// copy PAGE routine into ROM's($fc00-$fcff)
	pROM=(uint32*) ROMS[4];
	for (i2=5;i2<MAXROM;i2++){
		pMem=(uint32*) ROMS[i2];
		for (i=0xf00;i<0xf00+64;i++){
			pMem[i]=pROM[i];
		}
	}


	printf ("         Creating Tables\n");
	DefineOpcodeTable();
	mem_break=0;
	ROM=1;					// Set roms active!
	ROMINF=0x400;			// Set default roms to use

	//
	// Now, set up memory WRITEs to go to rom LOW and HIGH routines
	//
	SetRomZone (0x400);
	
	_PC=Deek(0xfffc);		// 0xf2a4;			// reset computer
	_SP=0xFF;
	_A=0;
	_Y=0;
	_X=0;
	_F=0;

	_A=0xff;

	ScreenLine=0;
	RasterLine=SCREEN_LINES-20;
	Memory [0xff1c]=((RasterLine>>8)|0xfe);		// set continuous raster
	Memory [0xff1d]=(RasterLine&255);				// set continuous raster

	pScreenData=&ScreenData[0];
	pScreenDataAddress=&ScreenData[0];
	_screen=0;
	
	i3=0;
	for (i=0;i<25;i++){
	  for (i2=0;i2<40;i2++) {
		ScreenIndexArray[(i*8*40)+i2]=i3;
		ScreenIndexArray[(i*8*40)+i2+40]=i3;
		ScreenIndexArray[(i*8*40)+i2+(40*2)]=i3;
		ScreenIndexArray[(i*8*40)+i2+(40*3)]=i3;
		ScreenIndexArray[(i*8*40)+i2+(40*4)]=i3;
		ScreenIndexArray[(i*8*40)+i2+(40*5)]=i3;
		ScreenIndexArray[(i*8*40)+i2+(40*6)]=i3;
		ScreenIndexArray[(i*8*40)+i2+(40*7)]=i3;
		i3++;
	  }
	}
	ProcessJoyStick ();
	ScanKeyBoard();							// read keyboard for this frame.
}


//****************************************************************************
//                                                           -
//   Name    :                                               -
//   Function:                                               -
//                                                           -
//   In   :                                                  -
//   Out  :                                                  -
//                                                           -
// This need rewritten. Its very confusing. i.e. BAD! 
//
//	uint8		CharAttribute[40];				// read on the LAST line of the previous character
//	uint8		CharNumber[40];					// read on the FIRST line of the character
//
//****************************************************************************

ProcessScanLine(void)
{
	byte		opcode,op2,data,a;
	char  	key;
	int		I;
	uint16	rast,charset,charscreen,i;
	uint32	curs;
	uint16	Rast;
	uint32	Line;
	int32		Offset=0;
	int32		dontdraw=0,CL;
	uint8		*index;
	

	RasterLine=Memory[0xff1d]+((Memory[0xff1c]&1)<<8);
	pScreenData=&ScreenData[0];
	//Poke (0xff1e,0xff);

	if (ScreenLine<244){
		pScreenData->blank	= (Memory[0xff06]&0x10);		// screen blanked?

		//
		// get most of the data needed to render the scanline.
		//
		pScreenData->multicol= (Memory[0xff07]&0x10)|(Memory[0xff06]&0x40);	//MCM & ECM
		pScreenData->Invert  = (Memory[0xff07]&0x80);
		pScreenData->ScrollX = (Memory[0xff07]&0x0f);
		pScreenData->ScrollY = (Memory[0xff06]&0x0f);
		pScreenData->col0 = (Memory[0xff15]&0x7f);			// background colour
		pScreenData->col1 = (Memory[0xff16]&0x7f);
		pScreenData->col2 = (Memory[0xff17]&0x7f);
		pScreenData->col3 = (Memory[0xff18]&0x7f);
		pScreenData->col4 = (Memory[0xff19]&0x7f);			// border colour

		scroffset=4;		//(pScreenData->ScrollY&7)+1;

		//
		// Work out cycles needed on THIS scanline. NOT 1Mhz mode..
		//
		if ((Memory[0xff13]&2)!=0){
				CYCLES_PER_LINE=CYCLES_PER_LINE_ON;		// SLOW mode selected
				CPU_MODE=_1MHZ;
		} else{
			if ((pScreenData->blank!=0) AND ((ScreenLine>20) AND (ScreenLine<224))){
				if (((RasterLine-scroffset)&7)==0){			// first or last line of character?
					CYCLES_PER_LINE=40;							// this is where DMA steals cycles
				}else if (((RasterLine-scroffset)&7)==7){
					CYCLES_PER_LINE=40;	//CYCLES_PER_LINE_ON;
				} else {
					CYCLES_PER_LINE=CYCLES_PER_LINE_ON;
				}
				//CYCLES_PER_LINE=CYCLES_PER_LINE_ON;
				CPU_MODE=_1MHZ;
			} else {
				CYCLES_PER_LINE=CYCLES_PER_LINE_OFF;
				CPU_MODE=_1_78MHZ;
			}
		}
		IRQ_START_CYCLE=8;

		//
		// Use a fractional add to work out left to right raster counter
		// This register stores the high bits of a dot counter. This dot
		// counter goes from 0 to 455 (456 dots) so 0 to 227 is stored here
		// giving 228 "dots"
		//
		mem_ff1e_delta=0xE30000/CYCLES_PER_LINE;			// work out delta for scan line
		CycleIndex[0]=0;
		for (i=1;i<25;i++){
			CycleIndex[i]=CycleIndex[i-1]+mem_ff1e_delta;		// work out deltas for EVERY instuction length
		}
		mem_ff1e=0;		//CycleIndex[LineCycles];					// Add on the number of cycles used.
		Memory[0xff1e]=(uint8) (mem_ff1e>>16);
		

		//
		// Now check the Bit Map Mode (or BMM)
		//
		pScreenData->bmm  = (Memory[0xff06]&0x20);
		if (pScreenData->bmm!=0){
			pScreenData->BitMap =((Memory[0xff12]&0x38)<<10);		// move bits to the TOP!
		}


		//
		// work out screen address
		//
		charscreen=Memory[0xff14]&(~7);
		if ((ROM==0) OR (charscreen<0x80)) {
			pScreenData->ScreenAddress=(charscreen<<8)+Memory;
		} else {
			if (charset>=0xd0){
				pScreenData->ScreenAddress=((charscreen<<8)-0xc000)+ROMS[(ROMINF>>8)&0xff];
			} else {
				pScreenData->ScreenAddress=((charscreen<<8)-0x8000)+ROMS[(ROMINF&0xff)];
			}
		}

		Offset=0;
		if ((RasterLine>=4) AND (RasterLine<=203)){
			if (pScreenData->ScrollY!=0xb){
				switch (pScreenData->ScrollY&7){
				 case 0:		Offset=3; break;
				 case 1:		Offset=2; break;
				 case 2:		Offset=1; break;
				 case 3:		Offset=0; break;
				 case 4:		Offset=-1; break;
				 case 5:		Offset=-2; break;
				 case 6:		Offset=-3; break;
				 case 7:		Offset=-4; break;
				}
			}
		}


		//
		// get Cursor address
		//
		curs = (Memory[0xff0C]&3)*256;
		curs = Memory[0xff0D]+curs;
		pScreenData->Cursor = curs;


	  
		if (RasterLine==4){	//((pScreenData->ScrollY+1)&7)) {
			CharLine=0;
			CharRow=0;
			Memory[0xff1f]=CharLine;
			Memory[0xff1a]=(CharRow>>8)&3;
			Memory[0xff1b]=(CharRow&255);
		}

		CharRow=(Memory[0xff1a]<<8)+Memory[0xff1b];
		CharLine=Memory[0xff1f]&0x07;	//-pScreenData->ScrollY+1)&7;
		if (CharLine==0) {
			index=(uint8 *)pScreenData->ScreenAddress+CharRow;
			for (i=0;i<40;i++){
				CharNumber[i]=index[0x400];	// read NEXT character ROW
				CharAttribute[i]=*index;		// read NEXT Attribute ROW
				index++;
			}
		}
	

		//
		// work out character set..
		// 
		charset=Memory[0xff13]&(~3);
		if (((Memory[0xff12]&4)==0) OR (charset<0x80)){
			pScreenData->CharSet=(charset<<8)+Memory+((RasterLine-scroffset)&7);
		} else {
			if (charset>=0xd0){
				//pScreenData->CharSet=((charset<<8)-0xc000)+ROMS[(ROMINF>>8)&0xff]+((RasterLine-scroffset)&7);
				pScreenData->CharSet=((charset<<8)-0xc000)+ROMS[(ROMINF>>8)&0xff]+(CharLine&7);
			} else {
				//pScreenData->CharSet=((charset<<8)-0x8000)+ROMS[(ROMINF&0xff)]+((RasterLine-scroffset)&7);
				pScreenData->CharSet=((charset<<8)-0x8000)+ROMS[(ROMINF&0xff)]+(CharLine&7);
			}
		}
	

		CharLine=(Memory[0xff1f]&7);
		CharLine++;
		CharLine&=0x07;
		if (skipit==0){
			if (CharLine==0) CharRow+=40;										// NEXT character ROW has been reached.
		} else{
			skipit=0;
		}
		Memory[0xff1f]=CharLine+0xf0;
		Memory[0xff1a]=(CharRow>>8)&3;
		Memory[0xff1b]=(CharRow&255);

//		if (Offset!=0){
//			if (((ScreenLine-scroffset-Offset)>=20) AND 
//			    ((ScreenLine-scroffset-Offset)<=23)) {
//				dontdraw=1;
//			}
//		} 

		if ((RasterLine>=(200+scroffset)) OR (RasterLine<scroffset)) {
			pScreenData->blank	= 0;		// blank screen
		} 

		//
		// Y scroll active! (well borders active)
		//
		if (pScreenData->blank!=0){
			if ((pScreenData->ScrollY&8)==0){
				if ((RasterLine-Offset>=4) AND (RasterLine-Offset<=7)){
					dontdraw=1;
				} else if ((RasterLine-Offset>=200) AND (RasterLine-Offset<=203)){
					dontdraw=1;
				} 
			}
		}
		//
		// DRAW scan line!
		//
		charcount++;
		if (pScreenData->blank!=0){
			if ((pScreenData->ScrollY&8)==0){
				if (ScreenLine-scroffset-Offset<=20) 
				pScreenData->blank	= 0;		// blank screen
			}
		}
		  
		if (pScreenData->blank==0){
			Offset=0;
		}

		

		if (dontdraw==0){
			PrintScreen((ScreenLine-scroffset-Offset)*Xsize,
							(RasterLine-scroffset)*40,
							((RasterLine-scroffset)&7)+(((RasterLine-scroffset)>>3)*320));
		}


		//
		// Fix up borders
		//
		if ((pScreenData->ScrollY&8)==0){
			if ((RasterLine>=4) AND (RasterLine<=7)){
					pScreenData->blank	= 0;		// blank screen
					PrintScreen((ScreenLine-scroffset)*Xsize,	0,		0);
			} else if ((RasterLine>=200) AND (RasterLine<=203)){
					pScreenData->blank	= 0;		// blank screen
					PrintScreen((ScreenLine-scroffset)*Xsize,	0,		0);
			} 
		}
	}
}


//****************************************************************************
//
// Process a 6502 Instruction
//
//****************************************************************************
void Process6502 ( void )
{
	byte		op2,data;
	char  	key;
	int		I,i;
	uint16	rast;
	uint8		T;
	uint16	tim;
	uint8		CHAR;
	void		*test;
	uint16	TT;
	uint32	TimerCounter;
	int32		tempirq;
	float		TempSample;
	
	opcode=GETABYTE();
	Opcode_JumpTable[opcode]();

//	Memory[0xfef0]=0;				// force NO disk drive!!
//	Memory[0x01]=0x80;

	mem_ff1e+=CycleIndex[Cycles];					// Add on the number of cycles used.
	Memory[0xff1e]=(uint8) (mem_ff1e>>16);
	LineCycles+=Cycles+NextCycles;
	NextCycles=0;

//	if (DoneSample==0){
//		if (mem_ff1e>(114<<16)) {
//			pBuffer1[1+(RasterLine*2)]=((Memory[0xff11]&0x0f)*8)+128;	// create sample!
//		}
//		DoneSample=1;
//	}
	

	//
	// Process TIMERS
	//

	if ((Memory[0xff02]--)==0xff)
		if ((Memory[0xff03]--)==0xff)
			Memory[0xff09]|=0x10;			// set IRQ NOW!!!

	if ((Memory[0xff04]--)==0xff) 
		if ((Memory[0xff05]--)==0xff)
			Memory[0xff09]|=0x40;			// set IRQ NOW!!!

	TimerCounter=cTimer1;						// get current timer
	if (TIMER1_LO==0){							// process counter?

		if (CPU_MODE==_1MHZ)
			cTimer1-=TimerCounts1[Cycles];		// work out NEW timer. 0.885Mhz
		else 
			cTimer1-=TimerCounts2[Cycles];		// work out NEW timer. 1.77Mhz

		if (cTimer1>TimerCounter) {
			cTimer1+=Timer1;						// reset timer
			Memory[0xff09]|=8;						// set IRQ NOW!!!
			data=Memory[0xff0a];						// get IRQ switch
			if ((_F&_I)==0) {						// IRQ's ON??
				if ((data&8)!=0){
						DushReg (_PC);
						PushReg (_F);
						_F|=_I;							// disable irqs...
						_PC=Deek(0xfffe);				// get IRQ vector
						NextCycles=8;					// 8 for the START of an IRQ
				}
			}
   	}
		Memory[0xff00]=*pTimer1Lo;		// write NEW timer LOW
		Memory[0xff01]=*pTimer1Hi;		// write NEW timer HIGH
	}

	//
	// Do raster things...+raster IRQ routine...
	//
	if (LineCycles>CYCLES_PER_LINE) {
		
		IRQrast=Memory[0xff0b]+((Memory[0xff0a]&1)<<8);		// get raster IRQ line
		LineCycles-=CYCLES_PER_LINE;			// next line count
 		ScreenLine++;

		if (ScreenLine>SCREEN_LINES) {
			ScreenLine=0;
			RasterLine=SCREEN_LINES-20;
			Memory [0xff1c]=((RasterLine>>8)|0xfe);		// set continuous raster
			Memory [0xff1d]=(RasterLine&255);			// set continuous raster
		}
		// normal...
		RasterLine=Memory[0xff1d]+((Memory[0xff1c]&1)<<8);

		if (ScreenLine==0){
			FlashCount+=8;
			FlashCount&=0x78;
			ProcessJoyStick ();
			ScanKeyBoard();							// read keyboard for this frame.
			ScreenOff=1;
			DoCursor();
			CopyScreen(0);		// refresh..
		}


		//
		// If raster was forced by user, don't INC
		//
		if (DontInc==0) RasterLine++; else DontInc=0;
		if (RasterLine>SCREEN_LINES) 	{
			RasterLine=0;
		}
		Memory [0xff1c]=((RasterLine>>8)|0xfe);		// set continuous raster
		Memory [0xff1d]=(RasterLine&255);				// set continuous raster
		//Memory [0xff1f]=0x80|FlashCount|(RasterLine-4)&7;
		DoLine=0;
		//ProcessScanLine();


		//
		// Work out sample value for THIS raster line.
		//
		TempSample=((float) (Memory[0xff11]&0xf))*15.9375f;
		if ((Memory[0xff11]&0x20)!=0) TempSample=TempSample*2.0f;
		pBuffer1[RasterLine]=(uint8) TempSample;

		if (RasterLine==311)	{
			if ((Memory[0xff11]&0x80)!=0)	{
				CopySample();
			} else {
				memset (pBuffer1,0,312);			// CLEAR sample buffer!!
				CopySample();
			}
		}
	}

				
	//tempirq=(IRQrast-1);
	//if (tempirq<0) tempirq=(SCREEN_LINES-1);
	tempirq=IRQrast;
	if (((tempirq==RasterLine) OR ((Memory[0xff09]&2)!=0)) AND (ThisLine==0)){
   	if (LineCycles>IRQ_START_CYCLE) {
			Memory[0xff09]|=2;			// set IRQ NOW!!!
			ThisLine=1;
			data=Memory[0xff0a];				// get IRQ switch
			Last_ff09=Memory[0xff09];
			if ((_F&_I)==0) {						// IRQ's ON??
				if ((data&2)!=0){
						DushReg (_PC);
						PushReg (_F);
						_F|=_I;							// disable irqs...
						_PC=Deek(0xfffe);				// get IRQ vector
						NextCycles=8;					// 8 for the START of an IRQ
				}
			}
		}
	} else if (IRQrast!=RasterLine) ThisLine=0;

	if (LineCycles>DRAW_LINE && DoLine==0){
		ProcessScanLine();
		if ((ModeX==1) AND (ScreenLine<244)) {
			Screen2=(ScreenLine*368)+(uint32)Screen;
			VidBase2=Frame+(ScreenLine*(368/4));
			CopyXmodeLine ();
		}
		DoLine=1;
	}		
}




//****************************************************************************
//                                                           -
//   Name    :                                               -
//   Function:                                               -
//                                                           -
//****************************************************************************

void wipe ( void )
{
	int i;
	for (i=0;i<256;i++){
		Keys2[i]=0;
	}
}


//****************************************************************************
//
// Process a 6502 Instruction
//
//****************************************************************************
void Process ( void )
{
	byte	opcode,op2;
	char  key;
	int	I,skip,address,i;
	char	s[128];
	word	t;
	uint8	FF1D;

	key=0x0;
	
	_ret=0;
	key=0x0;
	skip=0;
	
	wipe();	
	while ((_ret==0)) {
		Regs();
		
		//
		// RUN
		//
		if (Keys2[K_ESCAPE])	{
			wipe();	
			return;
		}

		if (Keys2[K_F6])	{					// save PCX file
				printf("Enter FULL Filename\n");
				wipe();	
				Restore_Keyboard ();
				scanf("%s",s);
				Initialise_Keyboard ();
				if (s!="") SaveDIB(&s);
		}
		if (Keys2[K_F5])	{					// VIEW screen (so far)
			wipe();	
			ScreenMode=BitMapScreen;
			InitScreen ();
			_screen=1;
			CopyScreen (1);
			while (Keys2[K_ESCAPE]==0)	{					// VIEW screen (so far)
				if (Keys2[K_SPACE]){
					wipe();
					FF1D=Memory[0xff1d];
			  		while (FF1D==Memory[0xff1d]){
						Process6502();			// trace..
					}
					CopyScreen (1);
			  }
			 if (Keys2[K_ENTER]){
					wipe();
					// run one line,
					FF1D=Memory[0xff1d];
			  		while (FF1D==Memory[0xff1d]){
						Process6502();			// trace..
					}
					// then run a SCREEN worth
			  		while ( (Memory[0xff1d]+((Memory[0xff1c]&1)<<8)) !=0 ){
						Process6502();			// trace..
					}
					CopyScreen (1);
			  }
			}
			SetMode(3);
			ScreenMode=CharScreen;
			_screen=1;
			CopyScreen (1);
			wipe();	
		}


		//
		// Restart
		//
		if (Keys2[K_F12])	{
			RomOn();					// ROM=1 - Set roms active!
			SetRomZone(0x400);	// Set defualt roms!
			DushReg (_PC);
			PushReg (_F);
			_PC=Deek(0xfffc);		// 0xf2a4;			// reset computer
			
			Keys[K_F12]=0;
			wipe();	
			return;
		}


		if (Keys2[K_S])	{ 
							  wipe();	
							  Restore_Keyboard ();
							  scanf("%s",s);
							  if (s[0]=='$')	
							  	newpc=GetHex(&s);
							  else
							  	newpc=Val(&s);				
							   Initialise_Keyboard ();
							  wipe();
							  return;
							 } 

		//
		// run until address is "touched"
		//
		if (Keys2[K_B]) { 
							  wipe();	
							  Restore_Keyboard ();
							  scanf("%s",s);
							  if (s[0]=='$')	
							  	brk_address=GetHex(&s);
							  else		  
							  	brk_address=Val(&s);				
							  mem_break=1;	
							  Initialise_Keyboard ();
							  wipe();
							  return;
							 }

		//
		// dump memory
		//
		if(Keys2[K_M])	{ 
							  wipe();	
							  Restore_Keyboard ();
							  scanf("%s",s);
							  if (s[0]=='$') 
									address=GetHex(&s); 
							  else	
									address=Val(&s);				
							  MemDump=address;
							  skip=1;	
							  Initialise_Keyboard ();
							 }


		if (Keys2[K_Q]) { EXIT_PRG=1; skip=2; wipe(); return; }


		//
		// goto address (PC=?)
		//
		if (Keys2[K_R]){
							  wipe();	
							  Restore_Keyboard ();
							  scanf("%s",s);
							  if (s[0]=='$')	
							  	newpc=GetHex(&s);
							  else
							  	newpc=Val(&s);				
							  _PC=newpc;
							  skip=1;	
							  Initialise_Keyboard ();
							 }


		if (Keys2[K_ENTER]) {
			wipe();
			Process6502();			// trace..
		}

//		if (_PC==newpc) {
//		 	//col^=1;
//			wipe();
//			return;			// PC break point!
//		}

		if (Keys[K_F9]) {
			wipe();
			Process6502();			// trace..
		}
		if (skip==2) return;
		skip=0;
		wipe();
	}
}

//****************************************************************************
//
// Process a 6502 Instruction
//
//****************************************************************************
void Process2 ( void )
{
	word		t;
	byte		opcode,op2,joytog=0,joytog2=0;
	char  	key;
	int		I,skip,address,i;
	char		s[128];
	char 		line[80];
	char 		f[7];
	char 		pc[5];
	char 		ar[3];
	char 		xr[3];
	char 		yr[3];
	char 		sp[3];
	int  		lp,aa;
	uint32	tt;
	int	handle;
	uint16	Add,doneline=0;


	key=0x0;
	
	_ret=0;
	key=0x0;
	skip=0;
	
	//Poke (0xff08,0xff);		// keyboard


	wipe();
	tt=0;
	while (1){
		Process6502();
		if (ScreenLine==10 && doneline==0) {
			
			doneline=1;
			if ((Keys[K_BREAK]!=0) AND (Keys[K_LEFTALT]!=0)) { 
				EXIT_PRG=1; 
				wipe();
				return; 
			}

			if (Keys[K_F5]) {		// Toggle joystick 1
				if (joytog==0){
					JOYSTICK^=1;
					joytog=1;
					Keys[K_F5]=0;
				}
			} else {
				joytog=0;
			}
			if (Keys[K_F6]) {		// Toggle joystick 2
				if (joytog==0){
					JOYSTICK^=2;
					joytog2=1;
					Keys[K_F6]=0;
				}
			} else {
				joytog2=0;
			}

			if (Keys[K_F10]) {
				if (pFileName==NULL){
					LoadProgram(".");
				} else {
					LoadProgram (pFileName);
				}
				Keys[K_F10]=0;
			}

			if (Keys[K_F11]) { 
				debug=1;
				Keys[K_F11]=0;
				return;
			}

			// Calabrate joystick.
			if (Keys[K_F8]){
				CalabrateJoystick();
				Keys[K_F8]=0;
				wipe();	
			}


			if (Keys[K_F12]) { 

				if (Keys[K_LEFTSHIFT] OR Keys[K_RIGHTSHIFT]){
					RomOn();					// ROM=1 - Set roms active!
					SetRomZone(0x400);	// Set defualt roms!
				}
				DushReg (_PC);
				PushReg (_F);
				_PC=Deek(0xfffc);		// 0xf2a4;			// reset computer
				Keys[K_F12]=0;
			}

			if (Keys['D']) {
				_A=_A+1;
				_A=_A-1;
				Keys['D']=0;
			}

			if (Keys[K_F9]) {
				FreezeGame();
				Keys[K_F9]=0;
//				handle=open ("test.dat",O_WRONLY|O_BINARY|O_CREAT,S_IRWXU|S_IRWXG);
//				Add=0x1001;
//				write (handle,&Add,2);
//				write (handle,&Memory[0x1001],0xd000);
//				close (handle);
			}

		} else {
			if (ScreenLine!=10) doneline=0;
		}

//		if (Keys2[K_F5]) {
//			wipe();
//			CYCLES_PER_LINE_ON--;
//			//NextCycle_base--;
//		}
//		if (Keys2[K_F6]) {
//			wipe();
//			CYCLES_PER_LINE_ON++;
//			//NextCycle_base++;
//
//		}
//		if (Keys2[K_F7]) {
//			wipe();
//			DRAW_LINE--;
//			//IRQ_START_CYCLE--;
//			//CYCLES_PER_LINE_OFF--;
//		}
//		if (Keys2[K_F8]) {
//			wipe();
//			DRAW_LINE++;
//			//IRQ_START_CYCLE++;
//			//CYCLES_PER_LINE_OFF++;
//		}
//		if (Keys2[K_F8]) {
//		 	col^=1;
//		}

		if (_PC==newpc) {
		 	//col^=1;
			wipe();
			return;			// PC break point!
		}
	   //if (do_break==1) return;		// TOUCHED memory location
	}
}








