//****************************************************************************
//
// Process the "AND" instruction 
//
//****************************************************************************
void ProcessAND_C_29( void ){
	word  address;
	byte  zpage;

	_A=_A&GETABYTE(); 
	Cycles=2; 

	DOCOMP (_A);
}

//----------------------------------------------------------------------------
void ProcessAND_C_25( void ){
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	_A&=Peek(zpage);        
	Cycles=3;

	DOCOMP (_A);
}

//----------------------------------------------------------------------------
void ProcessAND_C_35( void ){
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	_A&=Peek( (zpage+_X) &255);     
	Cycles=4; 

	DOCOMP (_A);
}

//----------------------------------------------------------------------------
void ProcessAND_C_2d( void ){
	word  address;
	byte  zpage;

	address=GETAWORD(); 
	_A&=Peek(address);    
	Cycles=4; 

	DOCOMP (_A);
}

//----------------------------------------------------------------------------
void ProcessAND_C_3d( void ){
	word  address;
	byte  zpage;

	address=GETAWORD(); 
	_A&=Peek(address+_X); 
	Cycles=4; 

	DOCOMP (_A);
}

//----------------------------------------------------------------------------
void ProcessAND_C_39( void ){
	word  address;
	byte  zpage;

	address=GETAWORD(); 
	_A&=Peek(address+_Y); 
	Cycles=4; 

	DOCOMP (_A);
}

//----------------------------------------------------------------------------

void ProcessAND_C_21( void ){
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	address=Deek( (zpage+_X) &255); 
	_A&=Peek(address);    
	Cycles=6; 

	DOCOMP (_A);
}

//----------------------------------------------------------------------------

void ProcessAND_C_31( void ){
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	address=Deek(zpage);    
	_A&=Peek(address+_Y); 
	Cycles=5; 

	DOCOMP (_A);
}

//----------------------------------------------------------------------------

void ProcessAND_C( void )
{
	word  address,a;
	byte  zpage;


	switch (opcode) {
	   case 0x29	:	_A=_A&GETABYTE(); Cycles=2; break;
	   case 0x25	:	zpage=GETABYTE(); _A&=Peek(zpage);        Cycles=3; break;
	   case 0x35	:	zpage=GETABYTE(); _A&=Peek((zpage+_X)&255);     Cycles=4; break;
	   case 0x2D	:	address=GETAWORD(); _A&=Peek(address);    Cycles=4; break;
	   case 0x3D	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								_A&=Peek(address+_X); 
								if (((address+_X)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0x39	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								_A&=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0x21	:	zpage=GETABYTE(); address=Deek((zpage+_X)&255); _A&=Peek(address);    Cycles=6; break;
	   case 0x31	:	{
								zpage=GETABYTE(); 
								address=Deek(zpage);    
								a=address&0xff00;
								_A&=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=6; 							// +1 for crossing page boundary
								} else {
									Cycles=5; 
								}
								break;
							}
	}

	DOCOMP (_A);
}

