//****************************************************************************
//
// Process the "ASL" instruction 
//
//****************************************************************************
void ProcessASL_C_0a( void ){
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);

	if ((_A&128)==128) { _F|=_C; }
	_A=_A<<1;
	if (_A==0)  { _F|=_Z; }
	if ((_A&128)==128) { _F|=_N; }

	Cycles=2;

}
//----------------------------------------------------------------------------

void ProcessASL_C_06( void ){
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);

	zpage=GETABYTE(); 
	data=Peek(zpage);

	if ((data&128)==128) { _F|=_C; }
	data=data<<1;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke(zpage,data); 	
	Cycles=5;

}
//----------------------------------------------------------------------------
void ProcessASL_C_16( void ){
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);

	zpage=GETABYTE(); 
	data=Peek( (zpage+_X) &255);

	if ((data&128)==128) { _F|=_C; }
	data=data<<1;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke( (zpage+_X) &255,data); 
	Cycles=6;

}
//----------------------------------------------------------------------------
void ProcessASL_C_0e( void ){
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);

	address=GETAWORD(); 
	data=Peek(address); 
	Poke(address,data);					// used to write to hardware!

	if ((data&128)==128) { _F|=_C; }
	data=data<<1;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke(address,data);  
	Cycles=6;

}
//----------------------------------------------------------------------------
void ProcessASL_C_1e( void ){
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);

	address=GETAWORD(); 
	data=Peek(address+_X); 

	if ((data&128)==128) { _F|=_C; }
	data=data<<1;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke(address+_X,data); 
	Cycles=7;
}
//----------------------------------------------------------------------------


void ProcessASL_C( void )
{
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);
	switch (opcode) {
	   case 0x0A	:	data=_A; break;
	   case 0x06	:	zpage=GETABYTE(); data=Peek(zpage); 	      break;
	   case 0x16	:	zpage=GETABYTE(); data=Peek((zpage+_X)&255); break;
	   case 0x0E	:	address=GETAWORD(); data=Peek(address); Poke(address,data);   break;
	   case 0x1E	:	address=GETAWORD(); data=Peek(address+_X); break;
	}

	if ((data&128)==128) { _F|=_C; }
	data=data<<1;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	switch (opcode) {
	   case 0x0A	:	_A=data; Cycles=2; break;
	   case 0x06	:	Poke(zpage,data); 	Cycles=5; break;
	   case 0x16	:	Poke((zpage+_X)&255,data); Cycles=6; break;
	   case 0x0E	:	Poke(address,data);  Cycles=6; break;
	   case 0x1E	:	Poke(address+_X,data); Cycles=7; break;
	}
}

