//****************************************************************************
//
// Process the "CMP" instruction 
//
//****************************************************************************
void ProcessCMP_C_c9( void ){
	word  address;
	byte  zpage;
	byte  test;

	data=GETABYTE(); 

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_A>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_A-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
	Cycles=2;
}

//----------------------------------------------------------------------------
void ProcessCMP_C_c5( void ){
	word  address;
	byte  zpage;
	byte  test;

	zpage=GETABYTE(); 
	data=Peek(zpage);        

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_A>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_A-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
	Cycles=3; 
}
//----------------------------------------------------------------------------
void ProcessCMP_C_d5( void ){
	word  address;
	byte  zpage;
	byte  test;

	zpage=GETABYTE(); 
	data=Peek( (zpage+_X) &255);     

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_A>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_A-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
	Cycles=4;
}
//----------------------------------------------------------------------------

void ProcessCMP_C_cd( void ){
	word  address;
	byte  zpage;
	byte  test;

	address=GETAWORD(); 
	data=Peek(address);    

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_A>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_A-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
	Cycles=4;
}
//----------------------------------------------------------------------------

void ProcessCMP_C_dd( void ){
	word  address;
	byte  zpage;
	byte  test;

	address=GETAWORD(); 
	data=Peek(address+_X); 

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_A>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_A-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
	Cycles=4;
}
//----------------------------------------------------------------------------

void ProcessCMP_C_d9( void ){
	word  address;
	byte  zpage;
	byte  test;

	address=GETAWORD(); 
	data=Peek(address+_Y); 

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_A>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_A-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
	Cycles=4;
}
//----------------------------------------------------------------------------

void ProcessCMP_C_c1( void ){
	word  address;
	byte  zpage;
	byte  test;

	zpage=GETABYTE(); 
	address=Deek( (zpage+_X) &255); 
	data=Peek(address);    

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_A>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_A-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
	Cycles=6;
}
//----------------------------------------------------------------------------

void ProcessCMP_C_d1( void ){
	word  address;
	byte  zpage;
	byte  test;

	zpage=GETABYTE(); 
	address=Deek(zpage);    
	data=Peek(address+_Y); 

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_A>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_A-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
	Cycles=5;
}
//----------------------------------------------------------------------------
void ProcessCMP_C( void )
{
	word  address,a;
	byte  zpage;
	byte  test;


	switch (opcode) {
	   case 0xC9	:	data=GETABYTE(); Cycles=2; break;
	   case 0xC5	:	zpage=GETABYTE(); data=Peek(zpage);        Cycles=3; break;
	   case 0xD5	:	zpage=GETABYTE(); data=Peek((zpage+_X)&255);     Cycles=4; break;
	   case 0xCD	:	address=GETAWORD(); data=Peek(address);    Cycles=4; break;
	   case 0xDD	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								data=Peek(address+_X); 
								if (((address+_X)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0xD9	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								data=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0xC1	:	zpage=GETABYTE(); address=Deek((zpage+_X)&255); data=Peek(address);    Cycles=6; break;
	   case 0xD1	:	{
								zpage=GETABYTE(); 
								address=Deek(zpage);
								a=address&0xff00;
								data=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=6; 							// +1 for crossing page boundary
								} else {
									Cycles=5; 
								}
								break;
							}
	}

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_A>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_A-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
}
