//****************************************************************************
//
// Process the "CPX" instruction 
//
//****************************************************************************
void ProcessCPX_C_e0( void )
{
	byte  data,test;
	

	data=GETABYTE(); 
	Cycles=2; 


	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_X>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_X-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
}

void ProcessCPX_C_e4( void )
{
	byte  	data,test;
	uint32	zpage;

	zpage=(uint32) GETABYTE(); 
	data=Peek(zpage);        
	Cycles=3; 


	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_X>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_X-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
}

void ProcessCPX_C_ec( void )
{
	byte  	data,test;
	uint32	address;

	address=GETAWORD(); 
	data=Peek(address);    
	Cycles=4; 


	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_X>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_X-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
}

void ProcessCPX_C( void )
{
	word  address;
	byte  zpage;
	byte  data,test;
	

	switch (opcode) {
	   case 0xE0	:	data=GETABYTE(); Cycles=2; break;
	   case 0xE4	:	zpage=GETABYTE(); data=Peek(zpage);        Cycles=3; break;
	   case 0xEC	:	address=GETAWORD(); data=Peek(address);    Cycles=4; break;
	}



	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_X>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_X-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
}

