//****************************************************************************
//
// Process the "CPY" instruction 
//
//****************************************************************************
void ProcessCPY_C_c0( void )
{
	word  address;
	byte  zpage;
	byte  test;
	
	data=GETABYTE(); 
	Cycles=2; 

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_Y>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_Y-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
}

void ProcessCPY_C_c4( void )
{
	word  	address;
	uint32   zpage;
	byte  	test;
	
	zpage=(uint32) GETABYTE(); 
	data=Peek(zpage);        
	Cycles=3; 

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_Y>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_Y-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
}
void ProcessCPY_C_cc( void )
{
	uint32  	address;
	byte  	test;
	
	address=GETAWORD(); 
	data=Peek(address);    
	Cycles=4; 

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_Y>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_Y-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
}

void ProcessCPY_C( void )
{
	word  address;
	byte  zpage;
	byte  test;
	

	switch (opcode) {
	   case 0xC0	:	data=GETABYTE(); Cycles=2; break;
	   case 0xC4	:	zpage=GETABYTE(); data=Peek(zpage);        Cycles=3; break;
	   case 0xCC	:	address=GETAWORD(); data=Peek(address);    Cycles=4; break;
	}
	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_Y>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_Y-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}
}
