//****************************************************************************
//
// Process the "DCM" instruction 
//
//	DCM    ***    (DCP)
//	This opcode DECs the contents of a memory location and then CMPs the result 
//	with the A register.
//
//	Supported modes:
//
//	DCM ab          ;C7 ab       ;            5
//	DCM ab,X        ;D7 ab       ;            6
//	DCM abcd        ;CF cd ab    ;No. Cycles= 6
//	DCM abcd,X      ;DF cd ab    ;            7
//	DCM abcd,Y      ;DB cd ab    ;            7
//	DCM (ab,X)      ;C3 ab       ;            8
//	DCM (ab),Y      ;D3 ab       ;            8
//
//****************************************************************************
void ProcessDCM_C( void )
{
	word  address;
	byte  zpage;
	byte  test;


	switch (opcode) {
	   case 0xC7	:	zpage=GETABYTE(); data=Peek(zpage)-1; Poke(zpage,data);       Cycles=5; break;
	   case 0xD7	:	zpage=GETABYTE(); data=Peek((zpage+_X)&255)-1;  Poke((zpage+_X)&255,data);   Cycles=6; break;
	   case 0xCF	:	address=GETAWORD(); data=Peek(address)-1; Poke(address,data);    Cycles=6; break;
	   case 0xDF	:	address=GETAWORD(); data=Peek(address+_X)-1; Poke (address+_X,data); Cycles=7; break;
	   case 0xDB	:	address=GETAWORD(); data=Peek(address+_Y)-1; Poke (address+_Y,data);Cycles=7; break;
	   case 0xC3	:	zpage=GETABYTE(); address=Deek((zpage+_X)&255); data=Peek(address)-1; Poke(address,data);   Cycles=8; break;
	   case 0xD3	:	zpage=GETABYTE(); address=Deek(zpage);    data=Peek(address+_Y)-1; Poke (address+_Y,data); Cycles=8; break;
	}

	_F&=(_I+_D+_V+_B);					// wipe flags
	if (_A>=data) {_F|=_C;}				// carry set when a>=data (clear = a<data)
	test=_A-data;
	if ((test&128)!=0) {_F|=_N;}		// sign bit set?
	if (test==0) {_F|=_Z;}

}
