//****************************************************************************
//
//
//        The Minus4 project - Copyright (c) Mike Dailly 1996,7
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//										  DISASM.C
//                                      
//					  The file contains the 6502 emulation
//
// Version  By   Date     Description
//
// v1.00    MD 08/04/95	  All Instructions emulated in high level
// V1.2	   MD 28/07/96	  Perhaps I should have kept up this list...
//                        I'll try in future.          		 
//                                 		 
//****************************************************************************
#include "headers\md.h"
#include "headers\all.h"
#include "headers\screen.h"
#include "headers\draw.h"
#include "headers\6502.h"
#include "headers\6502asm.h"


#define	  	IMM	0	
#define	  	ABS	1	
#define	  	ZPG	2	
#define	  	IMP	3	
#define	  	I_X	4	
#define	  	I_Y	5	
#define	  	Z_X	6	
#define	  	A_X	7	
#define	  	A_Y	8	
#define	  	REL	9	
#define	  	IND	10	
#define	  	Z_Y	11	

#define	  	DONE	255	

typedef struct	 {
			unsigned char		b;
			char					s[4];
			unsigned char		m;
} tTable;

  			
          	tTable Dtable[] = { 
		0x69,"ADC",IMM, 	0x6d,"ADC",ABS,	0x65,"ADC",ZPG,	0x61,"ADC",I_X,
		0x71,"ADC",I_Y,	0x75,"ADC",Z_X,	0x7d,"ADC",A_X,	0x79,"ADC",A_Y,

		0x29,"AND",IMM,	0x2d,"AND",ABS,	0x25,"AND",ZPG,	0x21,"AND",I_X,
		0x31,"AND",I_Y,	0x35,"AND",Z_X,	0x3D,"AND",A_X,	0x39,"AND",A_Y,

		0x0e,"ASL",ABS,	0x06,"ASL",ZPG,	0x0a,"ASL",IMP,	0x16,"ASL",Z_X,

		0x90,"BCC",REL,
		0xb0,"BCS",REL,
		0xF0,"BEQ",REL,

		0x2c,"BIT",ABS,	0x24,"BIT",ZPG,

		0x30,"BMI",REL,
		0xd0,"BNE",REL,
		0x10,"BPL",REL,

		0x00,"BRK",IMP,

		0x50,"BVC",REL,
		0x70,"BVS",REL,

		0x18,"CLC",IMP,
		0xd8,"CLD",IMP,
		0x58,"CLI",IMP,
		0xb8,"CLV",IMP,

		0xc9,"CMP",IMM,	0xcd,"CMP",ABS,	0xc5,"CMP",ZPG,	0xc1,"CMP",I_X,
		0xd1,"CMP",I_Y,	0xd5,"CMP",Z_X,	0xdd,"CMP",A_X,	0xD9,"CMP",A_Y,

		0xe0,"CPX",IMM,	0xec,"CPX",ABS,	0xe4,"CPX",ZPG,
		0xc0,"CPY",IMM,	0xcc,"CPY",ABS,	0xc4,"CPY",ZPG,

		0xce,"DEC",ABS,	0xc6,"DEC",ZPG,	0xd6,"DEC",Z_X,	0xde,"DEC",A_X,
		0xca,"DEX",IMP,
		0x88,"DEY",IMP,

		0x49,"EOR",IMM,	0x4D,"EOR",ABS,	0x45,"EOR",ZPG,	0x41,"EOR",I_X,
		0x51,"EOR",I_Y,	0x55,"EOR",Z_X,	0x5D,"EOR",A_X,	0x59,"EOR",A_Y,

		0xEE,"INC",ABS,	0xE6,"INC",ZPG,	0xF6,"INC",Z_X,	0xFE,"INC",A_X,
		0xE8,"INX",IMP,
		0xC8,"INY",IMP,

		0x4C,"JMP",ABS,   0x6C,"JMP",IND,
		0x20,"JSR",ABS,

		0xA9,"LDA",IMM,	0xAD,"LDA",ABS,	0xA5,"LDA",ZPG,	0xA1,"LDA",I_X,
		0xB1,"LDA",I_Y,	0xB5,"LDA",Z_X,	0xBD,"LDA",A_X,	0xB9,"LDA",A_Y,

		0xA2,"LDX",IMM,	0xAE,"LDX",ABS,	0xA6,"LDX",ZPG,
		0xBE,"LDX",A_Y,	0xB6,"LDX",Z_Y,

		0xA0,"LDY",IMM,	0xAC,"LDY",ABS,	0xA4,"LDY",ZPG,
		0xB4,"LDY",Z_X,	0xBC,"LDY",A_X,

		0x4E,"LSR",ABS,	0x46,"LSR",ZPG,	0x4A,"LSR",IMP,
		0x56,"LSR",Z_X,	0x5E,"LSR",A_X,

		0xEA,"NOP",IMP,

		0x09,"ORA",IMM,	0x0D,"ORA",ABS,	0x05,"ORA",ZPG,	0x01,"ORA",I_X,
		0x11,"ORA",I_Y,	0x15,"ORA",Z_X,	0x1D,"ORA",A_X,	0x19,"ORA",A_Y,

		0x48,"PHA",IMP,
		0x08,"PHP",IMP,
		0x68,"PLA",IMP,
		0x28,"PLP",IMP,

		0x2E,"ROL",ABS,	0x26,"ROL",ZPG,	0x2A,"ROL",IMP,
		0x36,"ROL",Z_X,	0x3E,"ROL",A_X,

		0x6E,"ROR",ABS,	0x66,"ROR",ZPG,	0x6A,"ROR",IMP,
		0x76,"ROR",Z_X,	0x7E,"ROR",A_X,

		0x40,"RTI",IMP,
		0x60,"RTS",IMP,

		0xE9,"SBC",IMM,	0xED,"SBC",ABS,	0xE5,"SBC",ZPG,	0xE1,"SBC",I_X,
		0xF1,"SBC",I_Y,	0xF5,"SBC",Z_X,	0xFD,"ORA",A_X,	0xF9,"SBC",A_Y,
		0xEB,"SBC",IMM,	// NOT a normal SBC opcode

		0x38,"SEC",IMP,
		0xF8,"SED",IMP,
		0x78,"SEI",IMP,

		0x8D,"STA",ABS,	0x85,"STA",ZPG,	0x81,"STA",I_X,	0x91,"STA",I_Y,
		0x95,"STA",Z_X,	0x9D,"STA",A_X,	0x99,"STA",A_Y,

		0x8E,"STX",ABS,	0x86,"STX",ZPG,	0x96,"STX",Z_Y,
		0x8C,"STY",ABS,	0x84,"STY",ZPG,	0x94,"STY",Z_X,

		0xAA,"TAX",IMP,
		0xA8,"TAY",IMP,
		0xBA,"TSX",IMP,
		0x8A,"TXA",IMP,
		0x9A,"TXS",IMP,
		0x98,"TYA",IMP,


// EXTRA OPCODES HERE!!


		0xEF,"INS",ABS,	0xE7,"INS",ZPG,	0xE3,"INS",I_X,	0xF3,"INS",I_Y,
		0xF7,"INS",Z_X,	0xFF,"INS",A_X,	0xFB,"INS",A_Y,

		0x8F,"AXS",ABS,	0x87,"AXS",ZPG,	0x97,"AXS",Z_Y,	0x83,"AXS",I_X,

		0x0F,"ASO",ABS,	0x07,"ASO",ZPG,	0x03,"ASO",I_X,	0x13,"ASO",I_Y,
		0x17,"ASO",Z_X,	0x1F,"ASO",A_X,	0x1B,"ASO",A_Y,

		0xCF,"DCM",ABS,	0xC7,"DCM",ZPG,	0xC3,"DCM",I_X,	0xD3,"DCM",I_Y,
		0xD7,"DCM",Z_X,	0xDF,"DCM",A_X,	0xDB,"DCM",A_Y,

		0xAF,"LAX",ABS,	0xA7,"LAX",ZPG,	0xA3,"LAX",I_X,	0xb3,"LAX",I_Y,
		0xB7,"LAX",Z_X,	0xBF,"LAX",A_Y,


		0x1A,"NOP",IMP,	0x3A,"NOP",IMP,	0x5A,"NOP",IMP,	0x7A,"NOP",IMP,
		0xDA,"NOP",IMP,	0xFA,"NOP",IMP,
		
		0xAB,"OAL",IMM,
		0x4B,"ALR",IMM,
		0xCB,"SAX",IMM,

		// Skip NEXT byte?!?!
		0x80,"SKB",ZPG,	0x82,"SKB",ZPG,	0xC2,"SKB",ZPG,	0xE2,"SKB",ZPG,
		0x04,"SKB",ZPG,	0x14,"SKB",ZPG,	0x34,"SKB",ZPG,	0x44,"SKB",ZPG,
		0x54,"SKB",ZPG,	0x64,"SKB",ZPG,	0x74,"SKB",ZPG,	0xD4,"SKB",ZPG,
		0xF4,"SKB",ZPG,	0x89,"SKB",ZPG,

		// Skip next word!
		0x0C,"SKW",ABS,	0x1C,"SKW",ABS,	0x3C,"SKW",ABS,	0x5C,"SKW",ABS,
		0x7C,"SKW",ABS,	0xDC,"SKW",ABS,	0xFC,"SKW",ABS,


		0x4F,"LSE",ABS,	0x47,"LSE",ZPG,	0x57,"LSE",Z_X,
		0x5F,"LSE",A_X,	0x5B,"LSE",A_Y,	0x43,"LSE",I_X,	0x53,"LSE",I_Y,


		0x6F,"RRA",ABS,	0x7F,"RRA",A_X,	0x7B,"RRA",A_Y,
		0x67,"RRA",ZPG,	0x77,"RRA",Z_X,	0x63,"RRA",I_X,	0x73,"RRA",I_Y,

		0x2f,"RLA",ABS,	0x3f,"RLA",A_X,	0x3b,"RLA",A_Y,
		0x27,"RLA",ZPG,	0x37,"RLA",Z_X,	0x23,"RLA",I_X,	0x33,"RLA",I_Y,

		0x02,"HLT",IMP,	0x12,"HLT",IMP,	0x22,"HLT",IMP,	0x32,"HLT",IMP,
		0x42,"HLT",IMP,	0x52,"HLT",IMP,	0x62,"HLT",IMP,	0x72,"HLT",IMP,
		0x92,"HLT",IMP,	0xB2,"HLT",IMP,	0xD2,"HLT",IMP,	0xF2,"HLT",IMP,

		0xff,"???",DONE};


		uint32			debug=0;
		char				disline[256];
		char				_OPCODE[16];
		unsigned char	MODE;
		char				ModeLine[40];
		char				_Hex[40];
		int				adder;
		uint32			*RoutineMap;
		uint32			*DataMap;

//****************************************************************************
//
// Display Registers
//
//****************************************************************************
void PrintLineC ( int x,int y, char *s )
{
	char	*Scr;

	Scr=(char *)0xb8000+(x*2)+(y*160);
	while (*s!=0x0){
		if (s[0]!='\n') { *Scr=*s++; } else {s++;}
		Scr+=2;
	}
}


//****************************************************************************
//
// Define Opcode DIS-Table
//
//****************************************************************************
void	SearchOpcode (unsigned char opcode)
{
	int	i,done;

	done=0;
	i=0;
	while (done==0) {
		if ((opcode==Dtable[i].b) || (Dtable[i].m==DONE)) {
			done=1;
			strcpy (_OPCODE,Dtable[i].s);
			MODE=Dtable[i].m;
		}
		i++;
	}

}

//****************************************************************************
//
// Define Opcode DIS-Table
//
//****************************************************************************
void GetModeLine( unsigned char MODE )
{
	char sb[10];
	char sw[10];
	char	b;
	unsigned short w,pc3;


	strcpy (sb,"00");
	strcpy (sw,"0000");
	pc3=_PC;
	w=GetWord();
	_PC=pc3;
	b=GetByte();
	Hex (&sb, b, 2);
	Hex (&sw, w, 4);


	switch (MODE) {
		case	IMM	:		adder=2; sprintf (ModeLine,"#$%s",sb);	break;
		case	ABS	:		adder=3; sprintf (ModeLine,"$%s",sw);	break;
		case	ZPG	:		adder=2; sprintf (ModeLine,"$%s",sb);	break;
		case	IMP	:		adder=1; sprintf (ModeLine," ");	break;
		case	I_X	:		adder=2; sprintf (ModeLine,"($%s,x)",sb);	break;
		case	I_Y	:		adder=2; sprintf (ModeLine,"($%s),y",sb);	break;
		case	Z_X	:		adder=2; sprintf (ModeLine,"$%s,x",sb);	break;
		case	A_X	:		adder=3; sprintf (ModeLine,"$%s,x",sw);	break;
		case	A_Y	:		adder=3; sprintf (ModeLine,"$%s,y",sw); break;
		case	REL	:		{
									adder=2; 
									if (b>127) {
										b=-b;
										_PC-=b;
									} else {
										_PC+=(int) b;
									}
									Hex (&sw, _PC, 4);
									sprintf (ModeLine,"$%s",sw); 	break;
								};
		case	IND	:		adder=3; sprintf (ModeLine,"($%s)",sw);	break;
		case	Z_Y	:		adder=2; sprintf (ModeLine,"$%s,y",sb);	break;
	}
}


//****************************************************************************
//
// Define Opcode DIS-Table
//
//****************************************************************************
void Disassemble( unsigned short PC_address )
{
	unsigned short 	PC2;  
	unsigned char		opcode;
	unsigned char		bData;
	unsigned short		wData;
	char					s1[80];


	PC2=_PC;
	strcpy(s1,"0000");
	strcpy(disline,"");
	strcpy(_OPCODE,"");
	strcpy(ModeLine,"");

	_PC=PC_address;
	opcode=GetByte();
	Hex (&s1, PC_address, 4);
	SearchOpcode(opcode);
	GetModeLine(MODE);
	sprintf (disline,"%s      %s   %s",s1,_OPCODE,ModeLine);
	_PC=PC2;
}





