//****************************************************************************
//
// Process the "EOR" instruction 
//
//****************************************************************************
void ProcessEOR_C_49( void )
{
	word  address;
	byte  zpage;


	_A^=GETABYTE(); 
	Cycles=2;
	COMP(_A);
}

void ProcessEOR_C_45( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE();
	_A^=Peek(zpage);
	Cycles=3;

	COMP(_A);
}

void ProcessEOR_C_55( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	_A^=Peek((zpage+_X)&255);     
	Cycles=4; 

	COMP(_A);
}


void ProcessEOR_C_4d( void )
{
	word  address;
	byte  zpage;

	address=GETAWORD(); 
	_A^=Peek(address);    
	Cycles=4;

	COMP(_A);
}

void ProcessEOR_C_5d( void )
{
	word  address;
	byte  zpage;

	address=GETAWORD(); 
	_A^=Peek(address+_X);
	Cycles=4;

	COMP(_A);
}

void ProcessEOR_C_59( void )
{
	word  address;
	byte  zpage;

	address=GETAWORD(); 
	_A^=Peek(address+_Y); 
	Cycles=4;

	COMP(_A);
}

void ProcessEOR_C_41( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	address=Deek((zpage+_X)&255); 
	_A^=Peek(address);    
	Cycles=6;

	COMP(_A);
}

void ProcessEOR_C_51( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	address=Deek(zpage);    
	_A^=Peek(address+_Y); 
	Cycles=5;

	COMP(_A);
}

void ProcessEOR_C( void )
{
	word  address,a;
	byte  zpage;


	switch (opcode) {
	   case 0x49	:	_A^=GETABYTE(); Cycles=2; break;
	   case 0x45	:	zpage=GETABYTE(); _A^=Peek(zpage);        Cycles=3; break;
	   case 0x55	:	zpage=GETABYTE(); _A^=Peek((zpage+_X)&255);     Cycles=4; break;
	   case 0x4D	:	address=GETAWORD(); _A^=Peek(address);    Cycles=4; break;
	   case 0x5D	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								_A^=Peek(address+_X); 
								if (((address+_X)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0x59	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								_A^=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0x41	:	zpage=GETABYTE(); address=Deek((zpage+_X)&255); _A^=Peek(address);    Cycles=6; break;
	   case 0x51	:	{
								zpage=GETABYTE(); 
								address=Deek(zpage);    
								a=address&0xff00;
								_A^=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=6; 							// +1 for crossing page boundary
								} else {
									Cycles=5; 
								}
								break;
							}
	}
	COMP(_A);
}
