//****************************************************************************
//
// Process the "LDA" instruction 
//
//	LAX ab          ;A7 ab       ;*=add 1     3
//	LAX ab,X        ;B7 ab       ;if page     4
//	LAX abcd        ;AF cd ab    ;No. Cycles= 4
//	LAX abcd,Y      ;BF cd ab    ;            4*
//	LAX (ab,X)      ;A3 ab       ;boundary    6
//	LAX (ab),Y      ;B3 ab       ;is crossed  5*
//
//****************************************************************************
void ProcessLAX_C( void )
{
	word  address;
	byte  zpage;
	switch (opcode) {
	   case 0xA7	:	zpage=GETABYTE(); _A=Peek(zpage); _X=_A; Cycles=3; break;
	   case 0xB7	:	zpage=GETABYTE(); _A=Peek((zpage+_X)&255); _X=_A;   Cycles=4; break;
	   case 0xAF	:	address=GETAWORD(); _A=Peek(address);  _X=_A; Cycles=4; break;
	   case 0xBF	:	address=GETAWORD(); _A=Peek(address+_Y); _X=_A; Cycles=4; break;
	   case 0xA3	:	zpage=GETABYTE(); address=Deek((zpage+_X)&255); _A=Peek(address); _X=_A; Cycles=6; break;
	   case 0xB3	:	zpage=GETABYTE(); address=Deek(zpage);    _A=Peek(address+_Y); _X=_A; Cycles=5; break;
	}
	COMP(_A);
}
