//****************************************************************************
//
// Process the "LDA" instruction 
//
//****************************************************************************
void ProcessLDA_C_a9( void )
{
	word  address;
	byte  zpage;

	_A=GETABYTE(); 
	Cycles=2; 

	COMP(_A);
}
void ProcessLDA_C_a5( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	_A=Peek(zpage);        
	Cycles=3;

	COMP(_A);
}
void ProcessLDA_C_b5( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	zpage+=_X;
	_A=Peek(zpage);     
	Cycles=4;

	COMP(_A);
}
void ProcessLDA_C_ad( void )
{
	word  address;
	byte  zpage;

	address=GETAWORD(); 
	_A=Peek(address);    
	Cycles=4;

	COMP(_A);
}
void ProcessLDA_C_bd( void )
{
	word  address;
	byte  zpage;

	address=GETAWORD()+_X; 
	_A=Peek(address); 
	Cycles=4;

	COMP(_A);
}
void ProcessLDA_C_b9( void )
{
	word  address;
	byte  zpage;

	address=GETAWORD()+_Y; 
	_A=Peek(address); 
	Cycles=4; 

	COMP(_A);
}
void ProcessLDA_C_a1( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	zpage+=_X;
	address=Deek(zpage); 
	_A=Peek(address);    
	Cycles=6; 

	COMP(_A);
}
void ProcessLDA_C_b1( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	address=Deek(zpage)+_Y;    
	_A=Peek(address); 
	Cycles=5; 

	COMP(_A);
}

void ProcessLDA_C( void )
{
	word  address,a;
	byte  zpage;

	switch (opcode) {
	   case 0xA9	:	_A=GETABYTE(); Cycles=2; break;
	   case 0xA5	:	zpage=GETABYTE(); _A=Peek(zpage);        Cycles=3; break;
	   case 0xB5	:	zpage=GETABYTE(); _A=Peek((zpage+_X)&255);     Cycles=4; break;
	   case 0xAD	:	address=GETAWORD(); _A=Peek(address);    Cycles=4; break;
	   case 0xBD	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								_A=Peek(address+_X); 
								if (((address+_X)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0xB9	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								_A=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0xA1	:	zpage=GETABYTE(); address=Deek((zpage+_X)&255); _A=Peek(address);    Cycles=6; break;
	   case 0xB1	:	{
								zpage=GETABYTE(); 
								address=Deek(zpage);    
								a=address&0xff00;
								_A=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=6; 							// +1 for crossing page boundary
								} else {
									Cycles=5; 
								}
								break;
							}
	}
	COMP(_A);
}
