//****************************************************************************
//
// Process the "LSR" instruction    _N=0     0->_A->_C
//
//****************************************************************************
void ProcessLSR_C_4a( void )
{
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);

	data=_A; 

	if ((data&1)==1) { _F|=_C; }
	data=data>>1;
	if (data==0)  { _F|=_Z; }

	_A=data; 
	Cycles=2;
}
void ProcessLSR_C_46( void )
{
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);

	zpage=GETABYTE(); 
	data=Peek(zpage);

	if ((data&1)==1) { _F|=_C; }
	data=data>>1;
	if (data==0)  { _F|=_Z; }

	Poke(zpage,data);    
	Cycles=5;
}
void ProcessLSR_C_56( void )
{
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);

	zpage=GETABYTE(); 
	zpage+=_X;
	data=Peek(zpage);

	if ((data&1)==1) { _F|=_C; }
	data=data>>1;
	if (data==0)  { _F|=_Z; }

	Poke(zpage,data); 
	Cycles=6;
}

void ProcessLSR_C_4e( void )
{
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);
	address=GETAWORD(); 
	data=Peek(address); 
	Poke(address,data); 			// Write back for IRQ's

	if ((data&1)==1) { _F|=_C; }
	data=data>>1;
	if (data==0)  { _F|=_Z; }

	Poke(address,data);  
	Cycles=6;
}
void ProcessLSR_C_5e( void )
{
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);
	address=GETAWORD()+_X; 
	data=Peek(address);

	if ((data&1)==1) { _F|=_C; }
	data=data>>1;
	if (data==0)  { _F|=_Z; }

	Poke(address,data); 
	Cycles=7;
}

void ProcessLSR_C( void )
{
	word  address;
	byte  zpage;

	_F&=(_V+_D+_I);
	switch (opcode) {
	   case 0x4A	:	data=_A; break;
	   case 0x46	:	zpage=GETABYTE(); data=Peek(zpage); 	  break;
	   case 0x56	:	zpage=GETABYTE(); data=Peek((zpage+_X)&255); break;
	   case 0x4E	:	address=GETAWORD(); data=Peek(address); Poke(address,data); break;
	   case 0x5E	:	address=GETAWORD(); data=Peek(address+_X); break;
	}

	if ((data&1)==1) { _F|=_C; }
	data=data>>1;
	if (data==0)  { _F|=_Z; }

	switch (opcode) {
	   case 0x4A	:	_A=data; Cycles=2; break;
	   case 0x46	:	Poke(zpage,data);    Cycles=5; break;
	   case 0x56	:	Poke((zpage+_X)&255,data); Cycles=6; break;
	   case 0x4E	:	Poke(address,data);  Cycles=6; break;
	   case 0x5E	:	Poke(address+_X,data); Cycles=7; break;
	}
}
