//****************************************************************************
//
// Process the "ORA" instruction 
//
//****************************************************************************
void ProcessORA_C_09( void )
{
	word  address;
	byte  zpage;

	_A|=GETABYTE(); 
	Cycles=2;
	COMP(_A);
}

void ProcessORA_C_05( void )
{
	word  address;
	byte  zpage;


	zpage=GETABYTE(); 
	_A|=Peek(zpage);
	Cycles=3;

	COMP(_A);
}
void ProcessORA_C_15( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	zpage+=_X;
	_A|=Peek(zpage);     
	Cycles=4;

	COMP(_A);
}

void ProcessORA_C_0d( void )
{
	word  address;
	byte  zpage;

	address=GETAWORD(); 
	_A|=Peek(address);    
	Cycles=4; 

	COMP(_A);
}

void ProcessORA_C_1d( void )
{
	word  address;
	byte  zpage;

	address=GETAWORD()+_X; 
	_A|=Peek(address); 
	Cycles=4;

	COMP(_A);
}
void ProcessORA_C_19( void )
{
	word  address;
	byte  zpage;

	address=GETAWORD()+_Y; 
	_A|=Peek(address); 
	Cycles=4;

	COMP(_A);
}

void ProcessORA_C_01( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	zpage+=_X;
	address=Deek(zpage); 
	_A|=Peek(address);    
	Cycles=6; 

	COMP(_A);
}
void ProcessORA_C_11( void )
{
	word  address;
	byte  zpage;

	zpage=GETABYTE(); 
	address=Deek(zpage)+_Y;    
	_A|=Peek(address); 
	Cycles=5;

	COMP(_A);
}

void ProcessORA_C( void )
{
	word  address,a;
	byte  zpage;


	switch (opcode) {
	   case 0x09	:	_A|=GETABYTE(); Cycles=2; break;
	   case 0x05	:	zpage=GETABYTE(); _A|=Peek(zpage);        Cycles=3; break;
	   case 0x15	:	zpage=GETABYTE(); _A|=Peek((zpage+_X)&255);     Cycles=4; break;
	   case 0x0D	:	address=GETAWORD(); _A|=Peek(address);    Cycles=4; break;
	   case 0x1D	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								_A|=Peek(address+_X); 
								if (((address+_X)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0x19	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								_A|=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0x01	:	zpage=GETABYTE(); address=Deek((zpage+_X)&255); _A|=Peek(address);    Cycles=6; break;
	   case 0x11	:	{
								zpage=GETABYTE(); 
								a=address&0xff00;
								address=Deek(zpage);    
								_A|=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=6; 							// +1 for crossing page boundary
								} else {
									Cycles=5; 
								}
								break;
							}
	}
	COMP(_A);
}



