//****************************************************************************
//
// Process the "ROL" instruction 
//
//****************************************************************************
void ProcessROL_C_2a( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=1;
	_F&=(_V+_D+_I);

	data=_A;
	
	if ((data&128)==128) { _F|=_C; }
	data=(data<<1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	_A=data;
	Cycles=2;
}
void ProcessROL_C_26( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=1;
	_F&=(_V+_D+_I);

	zpage=GETABYTE(); 
	data=Peek(zpage);
	
	if ((data&128)==128) { _F|=_C; }
	data=(data<<1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke(zpage,data);
	Cycles=5;
}
void ProcessROL_C_36( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=1;
	_F&=(_V+_D+_I);

	zpage=GETABYTE(); 
	zpage+=_X;
	data=Peek(zpage);
	
	if ((data&128)==128) { _F|=_C; }
	data=(data<<1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke(zpage,data); 
	Cycles=6;
}
void ProcessROL_C_2e( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=1;
	_F&=(_V+_D+_I);

	address=GETAWORD(); 
	data=Peek(address); 
	Poke(address,data);			// write back for IRQ's
	
	if ((data&128)==128) { _F|=_C; }
	data=(data<<1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke(address,data); 	
	Cycles=6;
}
void ProcessROL_C_3e( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=1;
	_F&=(_V+_D+_I);

	address=GETAWORD(); 
	address+=_X;
	data=Peek(address); 

	
	if ((data&128)==128) { _F|=_C; }
	data=(data<<1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke(address,data); 
	Cycles=7;
}

void ProcessROL_C( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=1;
	_F&=(_V+_D+_I);
	switch (opcode) {
	   case 0x2A	:	data=_A; break;
	   case 0x26	:	zpage=GETABYTE(); data=Peek(zpage);  break;
	   case 0x36	:	zpage=GETABYTE(); data=Peek((zpage+_X)&255); break;
	   case 0x2E	:	address=GETAWORD(); data=Peek(address); Poke(address,data);break;
	   case 0x3E	:	address=GETAWORD(); data=Peek(address+_X); break;
	}

	
	if ((data&128)==128) { _F|=_C; }
	data=(data<<1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	switch (opcode) {
	   case 0x2A	:	_A=data; Cycles=2; break;
	   case 0x26	:	Poke(zpage,data);  	Cycles=5; break;
	   case 0x36	:	Poke((zpage+_X)&255,data); Cycles=6; break;
	   case 0x2E	:	Poke(address,data); 	Cycles=6; break;
	   case 0x3E	:	Poke(address+_X,data); Cycles=7; break;
	}
}


