//****************************************************************************
//
// Process the "ROR" instruction 
//
//****************************************************************************
void ProcessROR_C_6a( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=128;
	_F&=(_V+_D+_I);

	data=_A;
	
	if ((data&1)==1) { _F|=_C; }
	data=(data>>1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	_A=data; 
	Cycles=2;
}
void ProcessROR_C_66( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=128;
	_F&=(_V+_D+_I);

	zpage=GETABYTE(); 
	data=Peek(zpage); 	

	
	if ((data&1)==1) { _F|=_C; }
	data=(data>>1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }


	Poke(zpage,data);
	Cycles=5;
}

void ProcessROR_C_76( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=128;
	_F&=(_V+_D+_I);

	zpage=GETABYTE(); 
	zpage+=_X;
	data=Peek(zpage);
	
	if ((data&1)==1) { _F|=_C; }
	data=(data>>1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke(zpage,data);
	Cycles=6;
}

void ProcessROR_C_6e( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=128;
	_F&=(_V+_D+_I);

	address=GETAWORD(); 
	data=Peek(address); 
	Poke(address,data);		// write back for IRQ's

	if ((data&1)==1) { _F|=_C; }
	data=(data>>1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke(address,data);
 	Cycles=6;
}

void ProcessROR_C_7e( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=128;
	_F&=(_V+_D+_I);

	address=GETAWORD(); 
	address+=_X;
	data=Peek(address);
	
	if ((data&1)==1) { _F|=_C; }
	data=(data>>1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	Poke(address,data); 
	Cycles=7;
}

void ProcessROR_C( void )
{
	word  address;
	byte  zpage;
	byte  t;

	t=0;
	if ((_F&_C)!=0) t=128;
	_F&=(_V+_D+_I);
	switch (opcode) {
	   case 0x6A	:	data=_A; break;
	   case 0x66	:	zpage=GETABYTE(); data=Peek(zpage); 	break;
	   case 0x76	:	zpage=GETABYTE(); data=Peek((zpage+_X)&255); break;
	   case 0x6E	:	address=GETAWORD(); data=Peek(address); Poke(address,data); break;
	   case 0x7E	:	address=GETAWORD(); data=Peek(address+_X); break;
	}

	
	if ((data&1)==1) { _F|=_C; }
	data=(data>>1)|t;
	if (data==0)  { _F|=_Z; }
	if ((data&128)==128) { _F|=_N; }

	switch (opcode) {
	   case 0x6A	:	_A=data; Cycles=2; break;
	   case 0x66	:	Poke(zpage,data);   	Cycles=5; break;
	   case 0x76	:	Poke((zpage+_X)&255,data); Cycles=6; break;
	   case 0x6E	:	Poke(address,data); 	Cycles=6; break;
	   case 0x7E	:	Poke(address+_X,data); Cycles=7; break;
	}
}

