//****************************************************************************
//
// Process the "SBC" instruction 
//
//****************************************************************************
void ProcessSBC_C_e9( void )
{
	word  address;
	byte  zpage,t,last;


	t=1;
	if ((_F&_C)!=0) t--;

	data=GETABYTE(); 
	Cycles=2; 


	_F&=(_D+_I+_C);
	_F|=_C;
	last=(_A-data-t);
	if (last>_A) _F&=(~_C);				// Clear Carry
	if (last==_A) {
		if ((data==0xff) AND (t==1)) _F&=(~_C);
	}
	_A=last;
	COMP(_A);
	
}
void ProcessSBC_C_e5( void )
{
	word  address;
	byte  zpage,t,last;


	t=1;
	if ((_F&_C)!=0) t--;

	zpage=GETABYTE(); 
	data=Peek(zpage);        
	Cycles=3;

	_F&=(_D+_I+_C);
	_F|=_C;
	last=(_A-data-t);
	if (last>_A) _F&=(~_C);				// Clear Carry
	if (last==_A) {
		if ((data==0xff) AND (t==1)) _F&=(~_C);
	}
	_A=last;
	COMP(_A);
	
}
void ProcessSBC_C_f5( void )
{
	word  address;
	byte  zpage,t,last;


	t=1;
	if ((_F&_C)!=0) t--;

	zpage=GETABYTE(); 
	data=Peek((zpage+_X)&255);     
	Cycles=4; 

	_F&=(_D+_I+_C);
	_F|=_C;
	last=(_A-data-t);
	if (last>_A) _F&=(~_C);				// Clear Carry
	if (last==_A) {
		if ((data==0xff) AND (t==1)) _F&=(~_C);
	}
	_A=last;
	COMP(_A);
	
}
void ProcessSBC_C_ed( void )
{
	word  address;
	byte  zpage,t,last;


	t=1;
	if ((_F&_C)!=0) t--;

	address=GETAWORD(); 
	data=Peek(address);    
	Cycles=4;

	_F&=(_D+_I+_C);
	_F|=_C;
	last=(_A-data-t);
	if (last>_A) _F&=(~_C);				// Clear Carry
	if (last==_A) {
		if ((data==0xff) AND (t==1)) _F&=(~_C);
	}
	_A=last;
	COMP(_A);
	
}
void ProcessSBC_C_fd( void )
{
	word  address;
	byte  zpage,t,last;


	t=1;
	if ((_F&_C)!=0) t--;

	address=GETAWORD(); 
	data=Peek(address+_X); 
	Cycles=4;

	_F&=(_D+_I+_C);
	_F|=_C;
	last=(_A-data-t);
	if (last>_A) _F&=(~_C);				// Clear Carry
	if (last==_A) {
		if ((data==0xff) AND (t==1)) _F&=(~_C);
	}
	_A=last;
	COMP(_A);
	
}
void ProcessSBC_C_f9( void )
{
	word  address;
	byte  zpage,t,last;


	t=1;
	if ((_F&_C)!=0) t--;

	address=GETAWORD(); 
	data=Peek(address+_Y); 
	Cycles=4;

	_F&=(_D+_I+_C);
	_F|=_C;
	last=(_A-data-t);
	if (last>_A) _F&=(~_C);				// Clear Carry
	if (last==_A) {
		if ((data==0xff) AND (t==1)) _F&=(~_C);
	}
	_A=last;
	COMP(_A);
}	
void ProcessSBC_C_e1( void )
{
	word  address;
	byte  zpage,t,last;


	t=1;
	if ((_F&_C)!=0) t--;

	zpage=GETABYTE(); 
	zpage+=_X;
	address=Deek(zpage); 
	data=Peek(address);    
	Cycles=6;

	_F&=(_D+_I+_C);
	_F|=_C;
	last=(_A-data-t);
	if (last>_A) _F&=(~_C);				// Clear Carry
	if (last==_A) {
		if ((data==0xff) AND (t==1)) _F&=(~_C);
	}
	_A=last;
	COMP(_A);
}
void ProcessSBC_C_f1( void )
{
	word  address;
	byte  zpage,t,last;


	t=1;
	if ((_F&_C)!=0) t--;

	zpage=GETABYTE(); 
	address=Deek(zpage);    
	data=Peek(address+_Y); 
	Cycles=5;

	_F&=(_D+_I+_C);
	_F|=_C;
	last=(_A-data-t);
	if (last>_A) _F&=(~_C);				// Clear Carry
	if (last==_A) {
		if ((data==0xff) AND (t==1)) _F&=(~_C);
	}
	_A=last;
	COMP(_A);
}

void ProcessSBC_C( void )
{
	word  address,a;
	byte  zpage,t,last;


	t=1;
	if ((_F&_C)!=0) t--;
	switch (opcode) {
		case 0xeb	:	// NOT a normal SBC opcode!!!
	   case 0xe9	:	data=GETABYTE(); Cycles=2; break;
	   case 0xe5	:	zpage=GETABYTE(); data=Peek(zpage);        Cycles=3; break;
	   case 0xf5	:	zpage=GETABYTE(); data=Peek((zpage+_X)&255);     Cycles=4; break;
	   case 0xeD	:	address=GETAWORD(); data=Peek(address);    Cycles=4; break;
	   case 0xfD	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								data=Peek(address+_X); 
								if (((address+_X)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0xf9	:	{
								address=GETAWORD(); 
								a=address&0xff00;
								data=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=5; 							// +1 for crossing page boundary
								} else {
									Cycles=4; 
								}
								break;
							}
	   case 0xe1	:	zpage=GETABYTE(); address=Deek((zpage+_X)&255); data=Peek(address);    Cycles=6; break;
	   case 0xf1	:	{
								zpage=GETABYTE(); 
								a=address&0xff00;
								address=Deek(zpage);    
								data=Peek(address+_Y); 
								if (((address+_Y)&0xff00)!=a){
									Cycles=6; 							// +1 for crossing page boundary
								} else {
									Cycles=5; 
								}
								break;
							}
	}
	_F&=(_D+_I+_C);
	_F|=_C;
	last=(_A-data-t);
	if (last>_A) _F&=(~_C);				// Clear Carry
	if (last==_A) {
		if ((data==0xff) AND (t==1)) _F&=(~_C);
	}
	_A=last;
	COMP(_A);
	
}
