//****************************************************************************
//
//
//        The Minus4 project - Copyright (c) Mike Dailly 1996,7
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//
//										 SCREEN.C
//                                      
//					 The file contains the SCREEN emulation
//
// Version  By   Date     Description
//
// v1.00    MD 12/04/95	  Basic screen emulation. ModeX 360x240 added.
//
//****************************************************************************
#include "headers\md.h"
#include "headers\all.h"
#include "headers\6502.h"
#include "headers\6502asm.h"
#include "headers\draw.h"
#include "headers\disasm.h"

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include "headers\twkuser.h"

#define	CharScreen		1
#define	BitMapScreen	2


	uint16	JoystickPort=JOYPORT;


   RegisterPtr rarray;
	int rsize;
	int y, lastMode;

	char 		Table[256]={"@ABCDEFGHIJKLMNOPQRSTUVWXYZ[] !\"#\$%&'()*+,-./0123456789:;<=>?-ABCDEFGHIJKLMNOPQRSTUVWXYZŰ ޱܱ                                                                                      -                                                             "};
	
	uint32	ModeX=MODEX;
	int16		xx,yy,Mouse,Moved,but;
	uint8		*Screen=NULL;
	uint32	ScreenTable[1024];


	uint8		ScreenMode=BitMapScreen;
	uint32	CharAddress[1000];
	uint32	ScreenOff=0;
	uint8		DOVBLANK=0;				// off by default

	// 
	// These are remembered each scan line for screen re-drawing...
	//

			tScreenInfo	ScreenData;
			tScreenInfo	*pScreenData;
			tScreenInfo	*pScreenDataAddress;
			uint32		Frame=0;
			uint8			col=0;

//***********************************************************
//                                                          * 
//   Name    : WaitVBlank                                   * 
//   Function: Wait for a vertical retrace.                 * 
//                                                          * 
//***********************************************************

void	WaitVBlank ()
{

	while ( (inp(0x3da) & 8)==8 );
	while ( (inp(0x3da) & 8)==0 );

}

//***********************************************************
//                                                          * 
//   Name    : SetColour                                    * 
//   Function: Sets a colour register to an R,G,B value     * 
//                                                          * 
//   In   : ColR=Colour Register to change                  * 
//          R   = Red   Colour Value                        * 
//          G   = Green Colour Value                        * 
//          B   = Blue  Colour Value                        * 
//   Out  : None                                            * 
//                                                          * 
//                                                          *
//***********************************************************

void	SetColour (int ColR, int R, int G, int B)
{
	outp ( ColourNo,   (unsigned char) ColR );
	outp ( ColourAttr, (unsigned char) R);// >> 2);
	outp ( ColourAttr, (unsigned char) G);// >> 2);
	outp ( ColourAttr, (unsigned char) B);// >> 2);
}


//****************************************************************************
//
// Copy over the TEXT screen.
//
//****************************************************************************
void CopyScreen ( void )
{
	int	x,y;
	int	address;
	byte	a;
	char	*Scr;

//	col=1;
	if (ScreenMode==CharScreen){
		Scr=(char *)0xb8000;
		address=0x0C00;					// Base of screen Plus4
		for (y=0;y<24;y++){
	  	for (x=0;x<40;x++){
				a=Peek(address++);
				a=Table[a];
				*Scr++=a;
				*Scr++=7;
	  	}
	 	Scr+=80;
		}
	} else {
			if (ModeX==1){
				Frame^=22080;
				if (col==1) SetColour(0,255,0,0);
				//CopyXmodeScreen();						// copy WHOLE page?
				if (col==1) SetColour(0,0,0,0);
				if (DOVBLANK==1) WaitVBlank();
				SetAddress((uint16) Frame);			// page flip!
			} else {
				if (col==1) SetColour(0,255,0,0);
				CopyBitMapScreen();
				if (col==1) SetColour(0,0,0,0);
				if (DOVBLANK==1) WaitVBlank();
			}
	}
}

//****************************************************************************
//
// Copy over the TEXT screen.
//
//****************************************************************************
void Cls ( void )
{
	int	x;
	char	*Scr;

	if (ScreenMode==CharScreen){
		Scr=(char *)0xb8000;
		for (x=0;x<2000;x++){
				*Scr++=32;
				*Scr++=7;
		}
	} else {
		//WaitVBlank();
		ClearScreen();
		CopyBitMapScreen();
	}
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void InitScreen ( void )
{
	uint32	i,i2,Scr,index;
	uint8		*pPal,a,b,c;

	if (ScreenMode!=CharScreen){
    	rsize = loadRegArray("360x240.256", &rarray);
		SetMode(0x13);

		if (ModeX==1){
			readyVgaRegs();
    		outRegArray(rarray, rsize);
			//outpw(0x3c4, 0x0f02);			/* Enable all 4 planes */

			SetAddress(0);
		}

		//
		// Only malloc the screen ONCE!!!
		//
		if (Screen==NULL){
			Screen=(uint8*) malloc (xres*yres);
			if (Screen==NULL) {
				SetMode(3);
				printf("Error: Can't allocate screen memory\n");
				exit(1);
			}
		} 
		pPal=&Palette[0];
		for (i=0;i<256;i++){
			a=*pPal++;
			b=*pPal++;
			c=*pPal++;
			SetColour(i,(a>>2),(b>>2),(c>>2));
		}

		//
		// Create screen table
		//
		Scr=(uint32) Screen;
		for (i=0;i<yres;i++){
			ScreenTable[i]=(uint32) Scr;
			Scr+=xres;
		}

		index=0;
		for (i=0;i<25;i++){
			for (i2=0;i2<40;i2++){
				CharAddress[index]=(i*Xsize*8)+(i2*8);
				index++;
			}
		}
		free(rarray);
	}
}


/*
    readyVgaRegs() does the initialization to make the VGA ready to
	accept any combination of configuration register settings.

	This involves enabling writes to index 0 to 7 of the CRT controller
	(port 0x3d4), by clearing the most significant bit (bit 7) of index
	0x11.
*/

void readyVgaRegs(void)
	{
	int v;
	outp(0x3d4,0x11);
    v = inp(0x3d5) & 0x7f;
	outp(0x3d4,0x11);
	outp(0x3d5,v);
	}

/*
	outReg sets a single register according to the contents of the
	passed Register structure.
*/

void outReg(Register r)
	{
	switch (r.port)
		{
		/* First handle special cases: */

		case ATTRCON_ADDR:
			inp(STATUS_ADDR);  		/* reset read/write flip-flop */
			outp(ATTRCON_ADDR, r.index | 0x20);
										/* ensure VGA output is enabled */
			outp(ATTRCON_ADDR, r.value);
			break;

		case MISC_ADDR:
		case VGAENABLE_ADDR:
			outp(r.port, r.value);	/*	directly to the port */
			break;

		case SEQ_ADDR:
		case GRACON_ADDR:
		case CRTC_ADDR:
		default:						/* This is the default method: */
			outp(r.port, r.index);	/*	index to port			   */
			outp(r.port+1, r.value);/*	value to port+1 		   */
			break;
		}
	}


/*
	outRegArray sets n registers according to the array pointed to by r.
	First, indexes 0-7 of the CRT controller are enabled for writing.
*/

void outRegArray(Register *r, int n)
	{
    readyVgaRegs();
	while (n--)
		outReg(*r++);
	}


/*
	loadRegArray opens the given file, does some validity checking, then
	reads the entire file into an array of Registers, which is returned
	via the array parameter.

	You will probably want to provide your own error handling code in
	this function, as it never aborts the program, rather than just
	printing an error message and returning NULL.

	The returned value is the number of Registers read.  The &array
	parameter is set to the allocated Register array.

	If you use this function, remember to free() the returned array
	pointer, as it was allocated dynamically using malloc() (unless NULL
	is returned, which designates an error)!
*/

int loadRegArray(char *fpath, RegisterPtr *array)
	{
	int handle, regs;
	long fsize;
	*array = NULL;

	if ((handle = open(fpath, O_BINARY | O_RDONLY)) == -1)
		/* error opening file */
		/* include your error handling code here */
		goto fileerror;

    if ((fsize = filelength(handle)) == -1)
		/* error acquiring file size */
		goto fileerror;
	if (fsize % sizeof(Register))
		{
		printf("Illegal TWEAK file size: %s\n", fpath);
		return 0;
		}
	regs = fsize / sizeof(Register);

    if (!(*array = (Register *)malloc(fsize)))
		{
		printf("Out of memory allocating buffer for %s\n", fpath);
		return 0;
		}
	if (read(handle, (void*)*array, fsize) == -1)
		/* error reading file */
		goto fileerror;

    if (close(handle) == -1)
		{
		/* error closing file */
		goto fileerror;
		}

	/* file read ok, return pointer to buffer */
	return regs;

fileerror:
	perror(fpath);
	if (*array) free(*array);
	return 0;
	}


void SetAddress(uint16	Address)
{
	outp(CRTC_ADDR, 0x0C);		/* set high byte */
	outp(CRTC_ADDR+1, Address >> 8);
	outp(CRTC_ADDR, 0x0D);		/* set low byte */
	outp(CRTC_ADDR+1, Address & 0xff);
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

typedef	struct tDIB {
//
//File header
//
		uint16	ASCII_BM;			//"BM" ID string
		uint32	filesize;
		uint16	reserved1;
		uint16	reserved2;
		uint32	ImageOffset;
//
// Image header
//
		uint32	SizeofImageHeader;		// always 40 bytes
		uint32	ImageWidth;					// in pixels
		uint32	ImageHeight;				// in pixels
		uint16	Planes;						// always 1
		uint16	BitsPerPixel;				// (1,4,8,24)
		uint32	Compression;				// 0=none, other=RLE
		uint32	CompressedImageSize;		// in bytes
		uint32	HorizRes;					// in pixels per meter?!?!?
		uint32	VertRes;						// in pixels per meter?!?!?
		uint32	NumberCols;					// palette entries used.
		uint32	NumberImport;				// important colours in palette?
		uint8		Palette[256*4];			// palette 4*N (B,G,R)
}tDIB;


void SaveDIB( char *FileName )
{
	int	handle;
	int32	i,i2;
	tDIB	DIB;
	uint8	*pScr;
	uint32	c;

//
// File Header
//
	DIB.ASCII_BM=0x4d42;							//"BM"
	//DIB.filesize=54+(4*256)+(360*240);		// file size
	DIB.filesize=54+(4*256)+(320*200);		// file size
	DIB.reserved1=0;
	DIB.reserved2=0;
	DIB.ImageOffset=54+(4*256);				// start of image
//
// Image header
//
	DIB.SizeofImageHeader=40;			// always 40
	//DIB.ImageWidth=360;					// in pixels
	//DIB.ImageHeight=240;					// in pixels
	DIB.ImageWidth=320;					// in pixels
	DIB.ImageHeight=200;					// in pixels
	DIB.Planes=1;							// always 1
	DIB.BitsPerPixel=8;					// (1,4,8,24)
	DIB.Compression=0;					// 0=none, other=RLE
	DIB.CompressedImageSize=0;			// in bytes
	DIB.HorizRes=0;						// in pixels per meter?!?!?
	DIB.VertRes=0;							// in pixels per meter?!?!?
	DIB.NumberCols=256;					// palette entries used.
	DIB.NumberImport=121;				// important colours in palette?

	i2=0;
	for (i=0;i<256;i++){
		DIB.Palette[i2  ]=Palette[(i*3)+2];	// B
		DIB.Palette[i2+1]=Palette[(i*3)+1];	// G
		DIB.Palette[i2+2]=Palette[(i*3)];		// R
		DIB.Palette[i2+3]=0;
		i2+=4;
	}

	handle=open (FileName,O_WRONLY|O_BINARY|O_CREAT,S_IRWXU|S_IRWXG);
	write (handle,&DIB,sizeof(tDIB));
	for (i=219;i>=20;i--){
	//for (i=239;i>=0;i--){
		c=(i*368);
		pScr=Screen;
		pScr+=c;
		write (handle,(pScr+20),320);
		//write (handle,pScr,360);
	}
	close (handle);
}
