//****************************************************************************
//
// Process the "STA" instruction 
//
//****************************************************************************
void ProcessSTA_C_85( void ){
	uint32  	zpage;

	zpage=(uint32) GETABYTE(); 
	Poke(zpage,_A);        
	Cycles=3;
}
//----------------------------------------------------------------------------
void ProcessSTA_C_95( void ){
	uint32  	zpage;

	zpage=(uint32) (GETABYTE()+_X); 
	zpage&=255;
	Poke(zpage,_A);     
	Cycles=4; 
}
//----------------------------------------------------------------------------

void ProcessSTA_C_8d( void ){
	uint32  	address;

	address=(uint32) GETAWORD(); 
	Poke(address,_A);    
	Cycles=4; 
}
//----------------------------------------------------------------------------

void ProcessSTA_C_9d( void ){
	uint32  	address;

	address=(uint32) (GETAWORD()+_X); 
	Poke(address,_A); 
	Cycles=5; 
}
//----------------------------------------------------------------------------
void ProcessSTA_C_99( void ){
	uint32  	address;
	byte  	zpage;

	address=(uint32) (GETAWORD()+_Y);
	Poke(address,_A);
	Cycles=5;
}

//----------------------------------------------------------------------------
void ProcessSTA_C_81( void ){
	uint32  	address;
	uint32  	zpage;

	zpage=(uint32) (GETABYTE()+_X); 
	zpage&=255;
	address=Deek( zpage );
	Poke(address,_A);
	Cycles=6;
}

//----------------------------------------------------------------------------
void ProcessSTA_C_91( void ){
	uint32  	address;
	uint32  	zpage;

	zpage=(uint32) GETABYTE(); 
	address=(uint32) (Deek(zpage)+_Y); 
	Poke(address,_A);
	Cycles=6; 
}

//----------------------------------------------------------------------------

void ProcessSTA_C( void ){

	word  	address;
	byte  	zpage;

	switch (opcode) {
	   case 0x85	:	zpage=GETABYTE(); Poke(zpage,_A);        Cycles=3; break;
	   case 0x95	:	zpage=GETABYTE(); Poke((zpage+_X)&255,_A);     Cycles=4; break;
	   case 0x8D	:	address=GETAWORD(); Poke(address,_A);    Cycles=4; break;
	   case 0x9D	:	address=GETAWORD(); Poke(address+_X,_A); Cycles=5; break;
	   case 0x99	:	address=GETAWORD(); Poke(address+_Y,_A); Cycles=5; break;
	   case 0x81	:	zpage=GETABYTE(); address=Deek((zpage+_X)&255); Poke(address,_A);    Cycles=6; break;
	   case 0x91	:	zpage=GETABYTE(); address=Deek(zpage); Cycles=6; Poke(address+_Y,_A); break;
	}
}
