;******************************************************************************
;
;
;        The Minus4 project - Copyright (c) Mike Dailly 1996,7
;
;
; This source and the Minus4 project remains the copyright of Mike Dailly, 
; but can be freely used and changed for NON-Commercial purposes. 
;
;								 Keep emulators free!
;
; Remember if you add or change anything, you MUST send a copy
; complete with source to me at mike@scotch.demon.co.uk
; If its just a bug fix, then just send the changed file, with a comment
; telling me WHERE you fixed and WHAT you fixed.
;
; 
;									 		    
;                                                                          
;******************************************************************************

WCSTACK	equ	1


	.486
IFDEF WCSTACK
        .MODEL  FLAT
ENDIF        
IFDEF WCREG
        .MODEL  FLAT,C
ENDIF        

sKEYBOARD       STRUCT
oldvecoff       DWORD   0       ; old user interrupt vector offset
oldvecseg       WORD    0       ; old user interrupt vector segment
valid           BYTE    0
sKEYBOARD       ENDS

KEY_SCAN_EVENT          equ     90000000h



	.DATA

	Public	Keys	
Keys	dword	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dword	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dword	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dword	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

	Public	Keys2
Keys2	dword	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dword	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dword	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dword	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

KEYBOARD		sKEYBOARD	<>



        .CODE

; ************************************************************************
;
; SaveKeyboardInterrupt
; ---------------------
; saves old keyboard interrupt vector
;
; ************************************************************************
	Public	SaveKeyboardInterrupt
SaveKeyboardInterrupt proc  C USES ds es esi edi edx ecx ebx eax 
	mov     ax,3509h                ; save the old vector
	int     21h
	mov     [KEYBOARD.oldvecseg],es
	mov     [KEYBOARD.oldvecoff],ebx
	mov     [KEYBOARD.valid], 1
	ret
SaveKeyboardInterrupt   ENDP

; ************************************************************************
;
; SetKeyboardInterrupt
; --------------------
; sets up new keyboard interrupt vector
;
; ************************************************************************
	Public	SetKeyboardInterrupt
SetKeyboardInterrupt proc  C USES es ds esi edi edx ecx ebx eax 
	mov     edx, SEG KeyboardInterupt
	mov     ds,edx
	mov     edx, OFFSET KeyboardInterupt
	mov     ax,2509h
	int     21h
	ret
SetKeyboardInterrupt    ENDP


; ************************************************************************
;
; Initialise_Keyboard
; -------------------
; initialises the keyboard for the game
;
; ************************************************************************
	Public	Initialise_Keyboard
Initialise_Keyboard proc  C USES ds es esi edi edx ecx ebx eax 
	mov	eax,255
lp:	mov	[eax+Keys],0
	dec	eax
	jnz	lp
	mov	Keys,0
	call  SaveKeyboardInterrupt
        call  SetKeyboardInterrupt
        ret
Initialise_Keyboard ENDP


; ************************************************************************
;
; ResetKeyboardInterrupt
; ----------------------
; restores the previous keyboard interrupt handler
;
;************************************************************************
	Public	ResetKeyboardInterrupt
ResetKeyboardInterrupt proc  C USES ds es esi edi edx ecx ebx eax 
	.IF     [KEYBOARD.valid]
	mov     ax,2509h                ; reset the old interrupt
	mov     edx,[KEYBOARD.oldvecoff]
	mov     ds,[KEYBOARD.oldvecseg]
	int     21h
	.ENDIF
	ret
ResetKeyboardInterrupt  ENDP


; ************************************************************************
;
; Restore_Keyboard
; ----------------
; restores the keyboard after the game
;
; ************************************************************************
	Public	Restore_Keyboard
Restore_Keyboard proc  C USES ds es esi edi edx ecx ebx eax 
	call  ResetKeyboardInterrupt
	ret
Restore_Keyboard ENDP





; ************************************************************************
;
; KeyboardInterupt
; -----------------
; Keyboard interrupt handler
; - replaces BIOS keyboard interrupt handler
;
; ************************************************************************

	Public	KeyboardInterupt
KeyboardInterupt proc  C USES edx eax

	xor	edx,edx
	in	al,60h				; get input key
	mov	dl,al         			; store scan code
	in	al,61h
	or	al,80h
	out	61h,al				; send acknowledgement
	and	al,7fh
	out	61h,al				; restore original value

	push	ds
	mov	ax, SEG Keys
	mov	ds,ax
	cmp	dl,128
	ja	@ClearTable				; key release?
	mov	byte ptr Keys[edx],255		; SET key as pressed
	mov	byte ptr Keys2[edx],255		; CLEAR key as pressed
	pop	ds
        mov     al,20h
        out     20h,al
	iretd

@ClearTable:
	and	dl,7fh
	mov	byte ptr Keys[edx],0		; CLEAR key as pressed
	pop	ds
        mov     al,20h
        out     20h,al
	iretd
KeyboardInterupt ENDP

	END
									

; ************************************************************************
;                               E O F
; ************************************************************************

