#//****************************************************************************
//
//
//        The Minus4 project - Copyright (c) Mike Dailly 1996,7
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//	Minus4 Written by:
// ------------------
//
// MD - Mike Dailly, Main framework and basic emulator.
//
//
// 
//
//****************************************************************************
#include <direct.h>
#include "dos.h"
#include "headers\md.h"
#include "headers\all.h"
#include "headers\screen.h"
#include "headers\draw.h"
#include "headers\6502.h"
#include "headers\6502asm.h"
#include "headers\disasm.h"
#include "headers\keyb.h"
#include	"headers\keyboard.h"
#include "headers\sound.h"
#include "headers\soundb.h"


	extern	char 		Table[256];

	tMenu		*pMenuFirst=NULL;				// first menu item
	tMenu		*pMenuLast=NULL;				// first menu item
	uint32	MenuCount=0;
	int32		MenuNumber1=0;
	int32		TIMER_ON=1;

	tDir		*pDir;
	uint8		SectorBuffer[256];
	char		*pCurrPath;
	uint8		done=0;
	uint32	VBLANK;
	

		uint32	sectors[40]={
					0,21,42,63,84,105,126,147,168,189,210,231,252,273,294,315,336,	// tracks 1-17
					357,376,395,414,433,452,471,
					490,508,526,544,562,580,
					598,615,632,649,666,
					683,700,717,734,751};

					

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
extern uint32	ROMINF;
extern uint32	ROM;
extern uint32	cTimer1;						// Current Timer
extern uint32	Timer1;						// timer init value
extern uint32	TIMER1_LO;							// value written to LOW?


void LoadFreezeGame( char *pName )
{
	int		handle;
	uint16	Add;

	handle=open (pName,O_RDONLY|O_BINARY);
	Add=0x0000;
	read (handle,&Add,2);						// write load address

	read (handle,&_PC,4);							// write register
	read (handle,&_F,4);							// write register
	read (handle,&_A,4);							// write register
	read (handle,&_X,4);							// write register
	read (handle,&_Y,4);							// write register
	read (handle,&_SP,4);							// write register

	read (handle,&ROMINF,4);						// write ROM bank data!
	read (handle,&ROM,4);							// ROM on/off?
	read (handle,&cTimer1,4);						// Current Timer
	read (handle,&Timer1,4);						// timer init value
	read (handle,&TIMER1_LO,4);							// value written to LOW?
	read (handle,Memory,0x10000);	// Dump ALL off memory!

	if (ROM==1){
		RomOn();						// ROM=1 - Set roms active!
	} else {
		RomOff();
	}
	SetRomZone (ROMINF);
	close (handle);
}
		
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

extern	uint8		*pCompTable2;
extern	uint8		CompTable;

void MakeCompTable( void )
{
	uint8		*pCompTable=&CompTable;
	uint8		F;
	uint16	test;
	
	pCompTable2=(((uint32) malloc(512)+255)&0xffffff00);

	for (test=0;test<256;test++){
		F=0;
		if ((test & 128)==128) {F|=_N;}
		if (test==0) {F|=_Z;}
		pCompTable[test]=F;
		pCompTable2[test]=F;
	}
}
	
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void AddMenu (uint8 ftype, char *pText, uint8 track, uint8 sector)
{
	tMenu *pMenu;


	pMenu=(tMenu *)malloc(sizeof(tMenu));
	if (pMenu==NULL) return;						// return if no memory

	pMenu->FileType=ftype;
	pMenu->Track=track;
	pMenu->Sector=sector;

	strcpy(pMenu->Text,pText);				// copy string

	if (pMenuFirst==NULL){
		pMenuFirst=pMenu;
		pMenuLast=pMenu;
	} else {
		pMenuLast->pNext=pMenu;
		pMenuLast=pMenu;
	}
	pMenu->pNext=NULL;
	MenuCount++;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void DeleteMenu ( void )
{
	tMenu	*pMenu=pMenuFirst;
	tMenu	*pMenu2;


	while (pMenu!=NULL){
		pMenu2=pMenu->pNext;			// get link
		free(pMenu);					// free memory
		pMenu=pMenu2;					// get NEXT link to follow
	}

	pMenuFirst=NULL;
	pMenuLast=NULL;
	MenuCount=0;
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void GetText (char *pText)
{
	int32	temp;

	temp=0;
	while (pText[temp]!=0){
				pText[temp]=Table[pText[temp]];
				temp++;
	}
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void GetSector (int handle, uint8 Track, uint8 Sector)
{
	lseek (handle,(sectors[Track-1]+Sector)*256, SEEK_SET);
	read (handle,&SectorBuffer[0],256);
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void PrintDir( int handle )
{
	int32	i,i2,temp;
	char	s[17];
	char	info[128];
	int	track;
	int	sector;
	char	*ptype;
	uint8	ty;
	char	prot;
	tMenu	*pMenu;



	track=18;
	sector=1;
	while (track!=0){
		GetSector(handle,track,sector);
		for (i=0;i<8;i++){
			pDir=(tDir *) &SectorBuffer[2+(sizeof(tDir)*i)];
			if ((pDir->FileType&0x7f)!=0){							// file deleted?

				switch (pDir->FileType&0x3f){
					case 1:	ptype="SEQ"; break;
					case 2:	ptype="PRG"; break;
					case 3:	ptype="USR"; break;
					case 4:	ptype="REL"; break;
				}
				if ((pDir->FileType&4)!=0) prot='>'; else prot=' ';

				s[16]=0x0;
				for (i2=0;i2<17;i2++) s[i2]=pDir->FileName[i2];
				sprintf (info,"%c%s    %s    %d",prot,ptype,s,pDir->NumberBlocks);
				GetText(&info);

				if ((pDir->FileType&0x3f)==2)
					AddMenu(1,&info, pDir->Track, pDir->Sector);				// CAN select
				else
					AddMenu(0,&info,0,0);				// CAN'T select
		
		
				//printf (info);
				//printf ("\n");
			}
		}
		track=SectorBuffer[0];
		sector=SectorBuffer[1];
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void PrintName ( int handle )
{
	char	s[32];
	int32	i,i2;

	GetSector (handle,18,0);		// get header block
	i2=1;
	s[0]='"';
	for (i=144;i<162;i++) {
		s[i2]=SectorBuffer[i]; 
		i2++;
	}
	s[i2]='"';
	i2++;
	for (i=162;i<167;i++) {
		s[i2]=SectorBuffer[i]; 
		i2++;
	}
	s[i2]=0x0;
	GetText(&s);
	AddMenu(0,&s[0],0,0);				// CAN'T select
	//printf(s);
	//printf("\n");
}


//************************************************************
//                                                           *
//   Name    : GetC64Dir                                     *
//   Function: return the complete directory of a D64 file   *
//                                                           *
//   In   : pFilename = file to get DIR of                   *
//   Out  : dir array filled.                                *
//                                                           *
//************************************************************
void GetC64Dir ( char *name )
{
	int handle;
	uint32	Size;

	Size=GetSize(name);
	
	handle=open (name,O_RDONLY|O_BINARY);
	if (handle!=-1) {
		printf ("    Loading Dir\n\n");
		PrintName ( handle );
		PrintDir( handle );
		close (handle);
	}
	
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void PrintMenu( uint32 start )
{
	tMenu	*pMenu;
	uint32	i;

	pMenu=pMenuFirst;
	while ((start!=0) AND (pMenu!=NULL)) {
		pMenu=pMenu->pNext;
		start--;
	}

	i=1;
	start=20;
	while ((start!=0) AND (pMenu!=NULL)) {
		PrintLine (20,i,&pMenu->Text[0]);
		start--;
		i++;
		pMenu=pMenu->pNext;
	}
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

int32		CheckStatus(int32 start)
{
	tMenu	*pMenu;
	uint32	i;
	int32		selected=start;

	pMenu=pMenuFirst;
	while ((start!=0) AND (pMenu!=NULL)) {
		pMenu=pMenu->pNext;
		start--;
	}

	if (pMenu==NULL) return -1;
	if (pMenu->FileType==0) return -1;

	return selected;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

tMenu	*GetInfo(int32 start)
{
	tMenu	*pMenu;
	uint32	i;
	int32		selected=start;

	pMenu=pMenuFirst;
	while ((start!=0) AND (pMenu!=NULL)) {
		pMenu=pMenu->pNext;
		start--;
	}

	return pMenu;			// return pointer
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
int32	ProcessMenu( int32 selected )
{
	int32		Top=0;
	uint8		firsttime=0;

	Wipe();

	if (selected<0) 
		selected=0;		// init = -1
	else {
		Top=selected;
	}

	while ((Keys2[K_ENTER]==0) AND (Keys2[K_ESCAPE]==0)){
		if((Keys2[K_UP]!=0) OR
		   (Keys2[K_DOWN]!=0) OR
		   (firsttime==0))
      { 
			firsttime=1;
			WaitVBlank ();
			Cls();	
			PrintMenu( Top );
			PrintLine (10,23,"Up and Down to change selection, then Enter to select");

			if (Keys2[K_UP]!=0)   { 
				if (selected>0) selected--; 
				wipe(); 
				if ((selected-Top)<0) Top--;
			}
			if (Keys2[K_DOWN]!=0) { 
				if (selected<MenuCount-1) selected++; 
				wipe(); 
				if ((selected-Top)>=20) Top++;
			}

			PrintLine (18,selected-Top+1,"->");
		}
	}

	selected=CheckStatus(selected);


	if (Keys2[K_ESCAPE]!=0) selected=-2;

	Wipe();
	return	selected;
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void LoadFile (char *pName,uint8 Track, uint8 Sector)
{
	int 		handle;
	uint32	Size,i,i2;
	uint16	Address,Add;
	uint8		first=0;
	int		h2;
	uint32	FileSize;

	Size=GetSize(pName);
	
	handle=open (pName,O_RDONLY|O_BINARY);
	if (handle!=-1) {
	
		while (Track!=0){
			GetSector(handle,Track,Sector);
			Track=SectorBuffer[0];
			Sector=SectorBuffer[1];

			if (first==0){
				Address=SectorBuffer[2];
				Address=Address+(SectorBuffer[3]*256);
				Add=Address;
				FileSize=0;

				if (Track==0) i2=Sector; else i2=256;
				for (i=4;i<i2;i++){
					Memory[Address]=SectorBuffer[i];
					Address++;
					FileSize++;
				}
				first=1;
			} else {

				if (Track==0) 
					i2=Sector+3; 
				else 
					i2=256;
				for (i=2;i<i2;i++){
					Memory[Address]=SectorBuffer[i];
					Address++;
					FileSize++;
				}
			}	

		}

		close (handle);
		//close (h2);
	}
	Doke(0x2b,0x1001);								// setup start of basic
	Doke(0x2d,(FileSize+Add-2));					// setup END of basic
	Doke(0x9d,(FileSize+Add-2));					// setup END of basic
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

int32 LoadD64(char *pName)
{
	int32		MenuNumber;
	tMenu		*pMenu;


	GetC64Dir (pName);
	MenuNumber=ProcessMenu(0);
	if (MenuNumber<0) {
		DeleteMenu();
		return MenuNumber;
	}

	pMenu=GetInfo(MenuNumber);				   					// get track and sector of first block!
	LoadFile (pName,pMenu->Track, pMenu->Sector);
	DeleteMenu();
	return MenuNumber;
}
//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void	GetDir (char	*pFileSpec)
{
struct dirent	*pDir;
	DIR		*pOpenDir;

	pOpenDir=opendir(pFileSpec);

	pDir=readdir(pOpenDir);
	while (pDir!=NULL){
		AddMenu (1,&pDir->d_name[0],0,0);
		pDir=readdir(pOpenDir);
	}
	closedir(pOpenDir);
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void LoadProgram ( char *pPath )
{
	int32		MenuNumber_temp;
	int32		MenuNumber2;
	tMenu		*pMenu;
	uint32	D64,PRG;
	char		Name[32];

	done=0;
	chdir (pPath);
	SetMode(3);
	ScreenMode=CharScreen;

	while (done==0) {
		GetDir("*.d64");			// include any .D64 files
		D64=MenuCount;
		GetDir("*.prg");			// include any .PRG files
		PRG=MenuCount;
		GetDir("*.FRE");			// include any .PRG files
	
		//
		// select them!
		// 
		MenuNumber_temp=MenuNumber1;
		MenuNumber1=ProcessMenu(MenuNumber1);
		if (MenuNumber1<0) {
			done=1;
			MenuNumber1=MenuNumber_temp;
		} else if (MenuNumber1<D64) {
			pMenu=GetInfo(MenuNumber1);				   					// get track and sector of first block!
			strcpy(&Name[0],&pMenu->Text[0]);
			DeleteMenu();
			MenuNumber2=LoadD64(&Name[0]);
			if (MenuNumber2>=0) done=1;
		} else if (MenuNumber1<PRG) {
			pMenu=GetInfo(MenuNumber1);				   					// get track and sector of first block!
			DeleteMenu();
			LoadGame(&pMenu->Text[0]);
			done=1;
		} else {
			pMenu=GetInfo(MenuNumber1);				   					// get track and sector of first block!
			DeleteMenu();
			LoadFreezeGame(&pMenu->Text[0]);
			done=1;
		}
			
	}
	chdir (pCurrPath);
	DeleteMenu();
	ScreenMode=BitMapScreen;
	InitScreen ();
	Cls();
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void (__interrupt __far *Old_Timer_Isr)();
int32	Icount=0;
#define	_50Hz			23863
#define	_60Hz			19886
#define	_SYSTEMTIME	0xFFFF

void __interrupt __far Timer ( void )
{
	Icount++;
	VBLANK=1;
	Old_Timer_Isr();
}

#define	CONTROL_8253	0x43
#define	CONTROL_WORD	0x3c
#define	COUNTER_0		0x40
#define	COUNTER_1		0x41
#define	COUNTER_2		0x42


void SetTimer ( uint32 val )
{
	outp ( CONTROL_8253, CONTROL_WORD );
	outp ( COUNTER_0,  (val&255) );
	outp ( COUNTER_0, ((val>>8)&255) );
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
extern	uint32			SBcount;

#define	TIMER_VEC	0x1c
void main ( int Count, char *argv[] )
{
	char		key;
	uint32	i;
	char		*Param;
	uint8		startdebug=0;

	SBcount=0;
	//
	// If you ADD anything to Minus4, feel free to add your name
   // here. But remember to send me a copy, complete with source!
	//
	printf ("\nMinus4 - The Plus/4 Emulator Version 1.2.2\n");
	printf ("   Copyright (C) Mike Dailly 1996,97\n\n\n");


	pCurrPath=getcwd(NULL,0);
	pFileName=NULL;
	if (Count>1){
		pFileName=argv[1];
		if (strcmp (pFileName,"/?")==0) { //OR (pFileName=="-?"))
			printf ("\nminus4 <Game Directory> [options]");
			printf ("\n-x = Disable ModeX and use Mode 13h (standard 320x200 256col)");
			printf ("\n-a = Disable AUDIO.");
			printf ("\n-t = Disable 50Hz/60Hz Timer");
			printf ("\n-s = ENABLE soundblaster samples (must be DMA 1 & PORT 220 just now)");
			printf ("\n-v = Enable vertical blank sync.");
			printf ("\n-d = Start in debug mode.\n");
			printf ("\n\n");
			exit (1);
		}
		if (Count>2){
			for (i=2;i<Count;i++){
				if (strcmp(argv[i],"-x")==0) ModeX=0;
				if (strcmp(argv[i],"-v")==0) DOVBLANK=1;
				if (strcmp(argv[i],"-d")==0) startdebug=1;
				if (strcmp(argv[i],"-a")==0) SOUND=0; 
				if (strcmp(argv[i],"-t")==0) TIMER_ON=0; 
				if (strcmp(argv[i],"-s")==0) SB_ON=1; 
			}
		}
	}

	if (TIMER_ON==1){
		Old_Timer_Isr=_dos_getvect( TIMER_VEC );	// get timer interrupt vector.
		_dos_setvect (TIMER_VEC, Timer);
		SetTimer ( _50Hz );
	}


	Initialise_Keyboard ();
	MakeCompTable();

	InitSound();
	InitSB ();


	printf ("Init 8501:\n");
	init6502();


   printf ("\n-------------------------------------------------\n\n");

	debug=startdebug;
	InitScreen ();
	SetMode(3);

	while (EXIT_PRG==0){
		if (debug==0){
		
			ScreenMode=BitMapScreen;
			InitScreen ();
			Cls();
			_screen=1;
			Process2();
			SetMode(3);
			debug=1;
		} else{
			ScreenMode=CharScreen;
			_screen=1;
			CopyScreen (0);
			Process();
			debug=0;
		}
	}
	SetMode(3);
	Restore_Keyboard ();
	ShutDownSound();
	DisableSB ();
	
	if (TIMER_ON==1){
		_dos_setvect (TIMER_VEC, Old_Timer_Isr );
		SetTimer ( _SYSTEMTIME );
		//printf ("%d\n",Icount);
	}
//	printf ("%d\n",SBcount);
}



