@echo off

set version=1
set revision=22

echo.
echo Building PC64Dos v%version%.%revision% (German & English)
echo Don't forget to change the version in File_ID.d and File_ID.e too!
echo.

if exist *.zip del *.zip

echo #define VERSION "%version%.%revision%">Version.h
echo #define HEXVER 0x0%version%%revision%>>Version.h

call devdirs

set l=d
set german=1
echo #define GERMAN>german.h

:nextlang

cd pc64
nmake MASTER=1 GERMAN=%german% /a /f pc64.mak all
cd ..
if errorlevel 1 goto end

cd pc64
doshelp /%l% /r
cd ..
if errorlevel 1 goto end

cd newname
nmake MASTER=1 GERMAN=%german% /a /f newname.mak all
cd ..
if errorlevel 1 goto end

cd t64top00
nmake MASTER=1 GERMAN=%german% /a /f t64top00.mak all
cd ..
if errorlevel 1 goto end

cd setjoy
nmake MASTER=1 GERMAN=%german% /a /f setjoy.mak all
cd ..
if errorlevel 1 goto end

cd testjoy
nmake MASTER=1 GERMAN=%german% /a /f testjoy.mak all
cd ..
if errorlevel 1 goto end

cd testcabl
nmake MASTER=1 GERMAN=%german% /a /f testcabl.mak all
cd ..
if errorlevel 1 goto end

cd dir64
nmake MASTER=1 GERMAN=%german% /a /f dir64.mak all
cd ..
if errorlevel 1 goto end

cd cbmtext
nmake MASTER=1 GERMAN=%german% /a /f cbmtext.mak all
cd ..
if errorlevel 1 goto end

if exist c:\pc64%l%%version%%revision%.zip del c:\pc64%l%%version%%revision%.zip
copy pc64\games.%l% pc64\games.txt
copy pc64\history.%l% pc64\history.txt
copy pc64\manual_%l%.doc pc64\manual.doc
copy pc64\file_id.%l% pc64\file_id.diz
pkzip -ex c:\pc64%l%%version%%revision%.zip @filelist.txt
del pc64\games.txt
del pc64\history.txt
del pc64\manual.doc
del pc64\file_id.diz

if "%l%"=="e" goto source
set l=e
set german=0
echo.>german.h
goto nextlang
:source

global for %%i in (*.bak *.tmp *.obj *.res *.lst *.map *.pch *.pdb *.rsp *.cfg *.err *.log) do del %%i
del pc64\pc64.exe
del pc64\pc64.hlp
del newname\newname.exe
del t64top00\t64top00.exe
del setjoy\setjoy.exe
del testjoy\testjoy.exe
del testcabl\testcabl.exe
del dir64\dir64.exe
del cbmtext\cbmtext.exe

if exist c:\pc64s%version%%revision%.zip del c:\pc64s%version%%revision%.zip
pkzip -ex c:\pc64s%version%%revision%.zip -rp *.*
pkzip -d c:\pc64s%version%%revision%.zip *.sts

cls
echo Build succesfull!
echo.
echo The following files have been created in your C:\ directory:
dir c:\pc64?%version%%revision%.zip

:end
set version=
set revision=
set l=
set german=
