//****************************************************************************
//
//
//
//        The Minus4 project - Copyright (c) Mike Dailly 1996,7
//
//
// This source and the Minus4 project remains the copyright of Mike Dailly, 
// but can be freely used and changed for NON-Commercial purposes. 
//
//								 Keep emulators free!
//
// Remember if you add or change anything, you MUST send a copy
// complete with source to me at mike@scotch.demon.co.uk
// If its just a bug fix, then just send the changed file, with a comment
// telling me WHERE you fixed and WHAT you fixed.
//
// 
//										 SOUNDB.C
//                                      
// This file holds the SOUND BLASTER stuff. This deals with playing plus/4
// samples (samples on the plus/4 are played by "clicking" the volume).
// It will also deal with the Plus/4 SID chip.
//
// Version  By   Date		Description
//  V0.01	MD	12/10/97		File started. play a sample. (test)
//                                 		 
//
//
//****************************************************************************
#include "headers\md.h"
#include "headers\all.h"
#include "headers\screen.h"
#include "headers\draw.h"
#include "headers\6502.h"
#include "headers\6502asm.h"
#include "headers\disasm.h"
#include "headers\keyb.h"
#include	"headers\keyboard.h"
#include <I86.h>
#include <dos.h>


// SoundBlaster SETUP
#define	BASEADDR			0x220       // SoundBlaster BASE address
#define	IRQ				7				// SoundBlaster IRQ
#define	DMAchannel		1           // SoundBlaster DMA channel


// PIC MASKS FOR MASK/DEMASK IRQ
#define	PICANDMASK		0x7f			// 01111111b 'AND' PIC mask for clear IRQ7
#define	PICORMASK		0x80			// 10000000b 'OR' PIC mask for set IRQ7

// DMA CONTROLLER REGISTERS :
#define	WRITEMASK		0x0a			// WRITE MASK REGISTER
#define	WRITEMODE		0x0b			// WRITE MODE REGISTER
#define	CLEARFLIPFLOP	0x0c
#define	PAGE_CHN			0x83			// PAGE REGISTER FOR DMAchannel 1
#define	BASE_CHN			0x02			// BASEADDRESS REGISTER DMA 1
#define	COUNT_CHN		0x03			// COUNT REGISTER DMAchannel 1

// SAMPLERATE : (if you change it pay attention to maximum samplerate)
//#define	TIMECONST		165         // = 10989 Hz (256-1000000/11000)


// This is 312 raster lines*50Hz refresh  = 15600
// This allows "amiga" style DMA, i.e. we get the data at the START of 
// each line. A simple way... Doubling it would be "nicer".
#define	TIMECONST		192         // = 15600 Hz (256-1000000/11000)
#define	BUFFER_SIZE		312
//#define	TIMECONST		224         // = 31200 Hz (256-1000000/11000)
//#define	BUFFER_SIZE		624

// DMA WRITE MODE
#define	WANTEDMODE		0x48			// 0x1001000b singlemode, nonautoinit, readmode


uint8 WAITWRITE( uint16 port );
#pragma aux WAITWRITE =		\
		"push	cx"				\
		"xor	cx,cx"			\
"lp:	dec	cx"				\
		"jz	endloop"			\
		"in	al,dx"			\
		"or	al,al"			\
		"js	lp"				\
"endloop:	pop	cx"		\
		parm caller [dx]		\
		modify [al]		\
	   value [al]


uint8 WAITREAD( uint16 port );
#pragma aux WAITREAD =		\
		"push	cx"				\
		"xor	cx,cx"			\
"lp:	dec	cx"				\
		"jz	endloop"			\
		"in	al,dx"			\
		"or	al,al"			\
		"jns	lp"				\
"endloop:	pop	cx"		\
		parm caller [dx]		\
		modify [al]		\
	   value [al]

typedef	struct tSB_DMA_Data{
	void  *SB_DMA_Cont; 		  	// pointer to continous allocated memory
	uint16 SB_DMA_Selector; 	// Base selector
	int32  SB_DMA_Channel;		// channel for dma transfer
	int32  SB_DMA_Mode; 		   // transfer mode
	uint16 SB_DMA_Length;		// # of bytes to transfer
	uint8	 SB_DMA_Page; 		   // page
}tSB_DMA_Data;

	uint32			SB_ON=0;					// SB "deactive" by default 
	uint32			SBNextFrameReady=0;
	uint32			SB_ready=0;			// ready for NEXT sample. (last one has stopped)
	uint32			SBcount=0;
	void 				(__interrupt __far *Old_IRQ_Isr)();		// old IRQ vector
	tSB_DMA_Data	buffer1,buffer2,buffer3;
	uint8	*p,*p2;

	// have "8" sample buffers ready for mixing

	uint8		*pBuffer1;	// TED samples
	uint8		*pBuffer2;	// SID channel 1
	uint8		*pBuffer3;	// SID channel 2
	uint8		*pBuffer4;	// SID channel 3
	uint8		*pBuffer5;	// SID samples
	uint8		*pBuffer6;
	uint8		*pBuffer7;
	uint8		*pBuffer8;	// output "mixed" channel

	uint32	BufferList[3];

unsigned int SB_IRQ_Mask1=-1;
unsigned int SB_IRQ_Mask2=-1;

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void SB_IRQ_Enable ( uint8 irqnum )
{
    uint8 tmp=1;

    if ( SB_IRQ_Mask1 == -1 )
        SB_IRQ_Mask1 = inp ( 0x21 );
    else if ( SB_IRQ_Mask2 == -1 )
        SB_IRQ_Mask2=inp ( 0xA1 );

    if ( irqnum < 8 )
        outp (0x21, (SB_IRQ_Mask1^(tmp<<irqnum) ) );     // IRQ 0-7
    else
        outp (0xA1, (SB_IRQ_Mask2^(tmp<<(irqnum-8)) ) );    // IRQ 8-15

}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void SB_IRQ_SetMask ( void )
{
    SB_IRQ_Mask1=inp ( 0x21 );
    SB_IRQ_Mask2=inp ( 0xA1 );
}


//************************************************************
//                                                           *
//   Name    : SB_DMA_Alloc											 *
//   Function: Allocate real "dos" memory. Not protected mode*
//             memory, as we need a real 20bit address.		 *
//                                                           *
//   In   : *DMA = a DMA structure									 *
//          size = amount to malloc                          *
//   Out  : 0 = okay                                         *
//          1 = error                                        *
//                                                           *
//************************************************************

int SB_DMA_Alloc ( tSB_DMA_Data *dma, int size )
{
	uint32 addr;
	static union REGS reg;

	reg.x.eax = 0x0100; 			 			// DPMI Mem. Allocation
	reg.x.ebx = ((size*2)+15>>4);			// # of paragraphs to alloc.
	int386 ( 0x31, &reg,&reg );			// do it!!

	if ( reg.x.cflag ) return 1;			// allocate error
	dma->SB_DMA_Selector=reg.x.edx;  	// get the base selector
	addr=(reg.x.eax&0xFFFF)<<4; 	 		// get the real segment adress

	// to guarantee page continous, allocate twice the size of mem pool.
	// used in mikxmas player........
	if ( (addr>>16) != ((addr+size-1)>>16) )
		addr+=size;

	dma->SB_DMA_Page=addr>>16;		 		// Get the page
	dma->SB_DMA_Cont = (void *) addr;	// get the 20 bit real adress
	dma->SB_DMA_Length=size;		 		// store the size of the data
	return 0;
}



//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

int SB_DMA_Free ( tSB_DMA_Data *dma )
{
	static union REGS reg;
	reg.x.eax = 0x0101; 						// DPMI mem. dealloc.
	reg.x.edx = dma->SB_DMA_Selector;	// get the selector
	int386 ( 0x31, &reg, &reg );			// do it!!
	if ( reg.x.cflag ) return -1;       // error dealloc --> exit
	return 0;                           // if not....KEWL !!!
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

int32 ResetDSP ( void )
{
	uint8	al;

	if (SB_ON==0) return 0;


	outp	(BASEADDR+6,1);		// Start DSP reset
	al=inp	(BASEADDR);
	al=inp	(BASEADDR);
	al=inp	(BASEADDR);
	al=inp	(BASEADDR);			// wait 3 sec

	outp	(BASEADDR+6,0);		// end DSP reset

	WAITREAD (BASEADDR+14);		// DSP DATA AVAILABLE flag

	al=inp (BASEADDR+10);		// DSP Read Data
	if (al==0xaa){					// is sound blaster THERE?!?!?! 
		return	0;
	}
	return	1;
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void StopSample ( void )
{
	if (SB_ON==0) return;


	WAITWRITE (BASEADDR+0xc);
	outp (BASEADDR+0xc,0xd0);				// AL = Halt DMA Operation, 8-bit
	WAITWRITE (BASEADDR+0xc);
	outp (BASEADDR+0xc,0xda);				// AL = terminate 8-bit DMA Operation
	WAITWRITE (BASEADDR+0xc);
	outp (BASEADDR+0xc,0xd0);				// AL = Halt DMA Operation, 8-bit
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
	extern	uint8	SampStart;
	extern	uint8	SampEnd;

int32 PlaySample ( tSB_DMA_Data *buffer )
{
	int32	i;
	uint32	SampleLength;

	if (SB_ON==0) return 0;


	SB_ready	=1;			// playing sample!
	SampleLength=BUFFER_SIZE;		// length of buffer

	outp (WRITEMASK,DMAchannel+4);
   outp (CLEARFLIPFLOP,DMAchannel+4);
	outp (WRITEMODE,WANTEDMODE+DMAchannel);

	// Write the 20 bit address
	outp (PAGE_CHN,(uint8) ( ((uint32) buffer->SB_DMA_Cont>>16)&0xff) );	
	outp (BASE_CHN,(uint8) ((uint32) buffer->SB_DMA_Cont&0xff));	
	outp (BASE_CHN,(uint8) ((uint32) buffer->SB_DMA_Cont>>8)&0xff);	

	// Write the length
	outp (COUNT_CHN,(uint8) (SampleLength&255));
	outp (COUNT_CHN,(uint8) ((SampleLength>>8)&255));

	// DMA enable mask
	outp (WRITEMASK, DMAchannel);


	// Now setup the soundblaster
	WAITWRITE (BASEADDR+0xc);
	outp (BASEADDR+0xc, 0x40);			// AL = Set timeconstant
	WAITWRITE (BASEADDR+0xc);
	outp (BASEADDR+0xc, TIMECONST);	


	WAITWRITE (BASEADDR+0xc);	
	outp (BASEADDR+0xc,0x14);			// AL = DMA DAC 8bit
	WAITWRITE (BASEADDR+0xc);	
	outp (BASEADDR+0xc,(uint8) (SampleLength&255));
	WAITWRITE (BASEADDR+0xc);	
	outp (BASEADDR+0xc,(uint8) ((SampleLength>>8)&255));

	return 0;
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void __interrupt __far SB_IRQ ( void )
{
	uint8	al;
	uint32	a;

	SBcount++;
	al=inp(BASEADDR+0xe);			// DSP DATA AVAILABLE (IRQ ACKNOWLEDGE)
	SB_ready=0;

//	a=BufferList[0];					// rotate buffers!
//	BufferList[0]=BufferList[1];
//	BufferList[1]=BufferList[2];
//	BufferList[2]=a;
//
//	if (SBNextFrameReady==1){				// Game Ready to carry on?
//		PlaySample ( (tSB_DMA_Data *) BufferList[0]);		//
//	}

	SBNextFrameReady=0;				// Next frame!
   outp(0x20,0x20);					// ACKNOWLEDGE HARDWARE INTERRUPT

//	Old_IRQ_Isr();
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************
void SetupIRQ ( void )
{
	uint32	al;

	al=inp	(0x21);			// SET MASK REGISTER BIT TO DISABLE INTERRUPT
	al&=PICANDMASK;
	outp (0x21,al);

	Old_IRQ_Isr=_dos_getvect( IRQ+8 );			// get IRQ7 vector
	_dos_setvect ( IRQ+8, SB_IRQ );	// Set NEW IRQ7 vector

	al=inp (0x21);
	al&=PICANDMASK; 			// CLEAR MASK REGISTER BIT TO ENABLE INTERRUPT
	outp (0x21,al);
}

void RestoreIRQ ( void )
{
	uint8	al;      

	al=inp(0x21);				// RESTORE PIC MASK
	al|=PICORMASK;				// <-- SET REGISTER MASK BITS TO DISABLE
   outp(0x21,al);

	_dos_setvect ( IRQ+8, Old_IRQ_Isr );

}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

void CopySample( void )
{
	tSB_DMA_Data *buffer;
	int32			 i;

	if (SB_ON==0) return;						// copy samples??


	buffer=(tSB_DMA_Data *)BufferList[1];	// get NEXT buffer to process
	memcpy ((uint8*) (buffer->SB_DMA_Cont),pBuffer1,BUFFER_SIZE);
}

//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

int32 InitSB ( void )
{
	int32	i;
	uint8	*p1,*p2,*p3;

	pBuffer1=malloc (1024);		// must ALWAYS malloc these!
	pBuffer2=malloc (1024);
	pBuffer3=malloc (1024);
	pBuffer4=malloc (1024);
	pBuffer5=malloc (1024);
	pBuffer6=malloc (1024);
	pBuffer7=malloc (1024);
	pBuffer8=malloc (1024);


	if (SB_ON==0) return 0;

	WAITWRITE(BASEADDR+0xc);
	outp	(BASEADDR+0xc,0xd1);   // ENABLE SB SPEAKERS (for all SBs <SB16)

	//SetUpIRQ();
	SB_DMA_Alloc ( &buffer1, 512 );	// allocate a tripple buffer
	SB_DMA_Alloc ( &buffer2, 512 );
	SB_DMA_Alloc ( &buffer3, 512 );

	p1=buffer1.SB_DMA_Cont;
	p2=buffer2.SB_DMA_Cont;
	p3=buffer3.SB_DMA_Cont;
	for (i=0;i<512;i++){
		*p1++=0;
		*p2++=0;
		*p3++=0;
	}   


	BufferList[0]=(uint32) &buffer1;		// PLAYING buffer
	BufferList[1]=(uint32) &buffer2;		// ready to play buffer
	BufferList[2]=(uint32) &buffer3;		// being built buffer

	PlaySample( (tSB_DMA_Data *)BufferList[0]);	// play next bit..
	return 0;
}


//************************************************************
//                                                           *
//   Name    :                                               *
//   Function:                                               *
//                                                           *
//   In   :                                                  *
//   Out  :                                                  *
//                                                           *
//************************************************************

int32	DisableSB ( void )
{
	if (SB_ON==0) return 0;

	if (SB_ready!=1){			// stop sample playing
		ResetDSP ();

	}
	SB_DMA_Free ( &buffer1 );
	SB_DMA_Free ( &buffer2 );
	SB_DMA_Free ( &buffer3 );

	//RestoreIRQ();
	return 0;
}


